package crawling;

import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;
import java.sql.Connection;
import java.sql.DriverManager;
import java.util.ArrayList;
import java.util.Properties;
import java.util.Scanner;

import crawling.database.DatabaseUpdateManager;

public class DhmoiExtracter {

	private final static String URL="http://www.ypes.gr/main.asp#1";
	private Connection connection;
	
	private final static String NOMOS_START_TAG = "<tr><td colspan=\"3\" height=\"25\" bgcolor=\"#FBF7E1\"><b>";
	private final static String NOMOS_END_TAG="</ul></td></tr>";
	
	private final static String DHMOS_START_TAG="&nbsp";
	private final static String DHMOS_END_TAG="<";
	
	private String source;
	
	public DhmoiExtracter(){
		if(openMySQLConnection()){
			read(AnnKeywords.GREEK_ENCODING);
		}else{
			System.exit(0);
		}
	}
	
	private void read(String encoding) {
		try {
			URLConnection connection = new URL(URL).openConnection();
			Scanner scanner = new Scanner(connection.getInputStream(), encoding);
			while (scanner.hasNext()) {
				source += scanner.next() + " ";
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	protected boolean openMySQLConnection() {
		try {
			Class.forName("com.mysql.jdbc.Driver");
			Properties props = new Properties();
			props.put("user", "root");
			props.put("password", "");
			props.put("useUnicode", "true");
			props.put("characterEncoding", "utf-8");
			connection = DriverManager.getConnection(
					"jdbc:mysql://localhost:3306/warehouse", props);
			return true;
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println("ERROR: Failed to get connection to database!");
			return false;
		}
	}
	
	public void extractDhmoi(){
		ArrayList<String> nomoiTexts = Utilities.extractAllTexts(source,NOMOS_START_TAG,NOMOS_END_TAG);
		for(String nomosText:nomoiTexts){
			nomosText+="<";
			ArrayList<String> dhmoiTexts = Utilities.extractAllTexts(nomosText,DHMOS_START_TAG,DHMOS_END_TAG);
			if(dhmoiTexts.get(0).contains("Áèçíþí")||dhmoiTexts.get(0).contains("ÁôôéêÞò")
					||dhmoiTexts.get(0).contains("Ðåéñáéþò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
				DatabaseUpdateManager.updateDhmoiTable(1,tempWord,typeId,connection);
				}
			}if(dhmoiTexts.get(0).contains("Áéôùëïáêáñíáíßáò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
				int typeId = extractTypeOfArea(tempWord);
				tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(11,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Áñãïëßäïò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
				int typeId = extractTypeOfArea(tempWord);
				tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(12,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Áñêáäßáò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
				int typeId = extractTypeOfArea(tempWord);
				tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(13,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Áñôçò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(14,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Á÷áúáò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(9,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Âïéùôßáò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(15,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Ãñåâåíþí")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(16,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("ÄñÜìáò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(17,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("ÄùäåêáíÞóïõ")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(18,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("¸âñïõ")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(19,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Åõâïßáò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(20,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Åõñõôáíßáò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(21,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Æáêýíèïõ")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(22,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Çëåßáò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(23,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Çìáèßáò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(24,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Çñáêëåßïõ")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(5,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Èåóðñùôßáò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(25,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Èåóóáëïíßêçò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(2,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Éùáííßíùí")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(8,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("ÊáâÜëáò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(7,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Êáñäßôóçò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(26,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("ÊáóôïñéÜò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(27,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Êåñêýñáò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(28,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Êåöáëëçíßáò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(29,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Êéëêßò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(30,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("ÊïæÜíçò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(32,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Êïñéíèßáò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(33,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("ÊõêëÜäùí")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(34,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Ëáêùíßáò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(35,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Ëáñßóçò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(4,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Ëáóéèßïõ")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(36,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("ËÝóâïõ")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(37,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("ËåõêÜäïò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(38,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Ìáãíçóßáò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(3,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Ìåóóçíßáò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(39,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("ÎÜíèçò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(40,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("ÐÝëëçò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(31,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Ðéåñßáò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(41,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("ÐñåâÝæçò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(42,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Ñåèýìíçò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(43,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Ñïäüðçò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(44,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("ÓÜìïõ")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(45,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Óåññþí")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(10,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("ÔñéêÜëùí")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(46,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Öèéþôéäïò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(47,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Öëùñßíçò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(48,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("Öùêßäïò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(49,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("×áëêéäéêÞò")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(50,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("×áíßùí")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(6,tempWord,typeId,connection);
					}
			}if(dhmoiTexts.get(0).contains("×ßïõ")){
				for(int i=1;i<dhmoiTexts.size();i++){
					String tempWord = WordUtilities.turnInToTotalCaps(dhmoiTexts.get(i));
					int typeId = extractTypeOfArea(tempWord);
					tempWord=tempWord.substring(3,tempWord.length());
					DatabaseUpdateManager.updateDhmoiTable(51,tempWord,typeId,connection);
					}
			}
		}
	}

	private int extractTypeOfArea(String word){
		if(word.startsWith("Ä."))return 1;
		return 2;
	}
	
	public static void main(String[] args){
		DhmoiExtracter dhmoiExtracter = new DhmoiExtracter();
		dhmoiExtracter.extractDhmoi();
	}
}
