/**
 * class ReadSource
 */
package crawling;
/**
 * Given a specific URL and type of Source this object extract the source of this url considering the 
 * character encoding that match with the type of source.
 */
import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;
import java.util.Scanner;

public class ReadSource {

	private String source;
    private String URI;
	
    
    /**
	 * Creates a reader object that contains the source of the given url with the propert encoding. 
	 * @param uri
	 * @param typeOfSource
	 * @see read(String)
	 */
    
	public ReadSource(String uri,int typeOfSource) {
		source = "";
		URI = uri;
		String encoding ="";
		if(typeOfSource == AnnKeywords.XRYSH_EYKAIRIA ){
			encoding = AnnKeywords.UTF8_ENCODING;
		}else if( typeOfSource == AnnKeywords.AGGELIOXWROS||typeOfSource==AnnKeywords.ESTATE || typeOfSource==AnnKeywords.KATHIMERINI){
			encoding = AnnKeywords.GREEK_ENCODING;
		}else if(typeOfSource== AnnKeywords.NEOMESITIKH){
			//encoding = AnnKeywords.WINDOWS_1253;
			encoding = AnnKeywords.UTF8_ENCODING;
		}
		read(encoding); 
	}

	/**
	 * Read the source of the given url in the given encoding
	 * @param encoding
	 */
	
    @SuppressWarnings("deprecation")
	
    public void read(String encoding) {
    	   Thread t = new Thread();
			t.start();

    	try {
			
			URLConnection connection = new URL(URI).openConnection();
			connection.setConnectTimeout(1000);
			Scanner scanner = new Scanner(connection.getInputStream(), encoding);
		    //int i=0;
			while ((scanner.hasNext())) {
				//System.out.println("source="+source);
				source += scanner.next()+" ";
			}
			//connection.setConnectTimeout(1000); 
			//t.interrupt();
			//System.out.println(t.isAlive());
			//System.out.println(connection.getExpiration());
			//System.out.println("Source \n "+ source);
			//System.out.println("Welcome       source="+source);
            
		}   catch (IOException e) {
			//long start = System.currentTimeMillis();
			//************************************************************
			//Xrysh Eukairia Case
			//Thread sleeping For 360000 ms until connection allowed.
			//***********************************************************
			System.out.println("Connection ERROR:Process Will Be Repeated...");
			System.out.println("Please Wait...A new Connection is going to be Established...\n");
			try {
				t.sleep(45000);
			} catch (InterruptedException e1) {
				//TODO Auto-generated catch block
				e1.printStackTrace();
			}
			//long elapsed = System.currentTimeMillis()-start;
            //System.out.println(elapsed); 
			//*********************************************************
			
			read(encoding);
		}
	}
    
	public String getSource() {
		return source;
	}

	public void setSource(String source) {
		this.source = source;
	}

}
