/**
 * class SellEarthFeatExtr
 * @author Dimitra Xidara
 */
package crawling;

import java.sql.Connection;

import crawling.AnnKeywords;
import crawling.Utilities;
import crawling.database.DatabaseSelectManager;
import crawling.entities.*;

public class SellEarthFeatExtr extends AnnFeatExtraction{

	protected PlotSellingAnnouncement annFeatures;
    
	public SellEarthFeatExtr(int nomosId,String announcement, Connection connection) {
		super(nomosId,announcement,connection);
		annFeatures = new PlotSellingAnnouncement();
		annFeatures.setOtherFeatures(announcement);
		editAnnFeatures();
	}

	protected void editAnnFeatures() {
		//String announcement="";//stal
		String[] annPieces = announcement.split(",");
		String areaPiece = annPieces[0];
		setAreas(areaPiece);
		IdDescription type = null;
		String price = null;
		String sxedio = null;
		String other = null;
		DoubleStringFormat embadon = null;
		String otherFeatures = annFeatures.getOtherFeatures();
		annPieces = otherFeatures.split(",");
		for (String piece : annPieces) {
			type = getType(piece.split(" "), DatabaseSelectManager.getTypesOfEarth(getConnection()));
			if (type != null) {
				annFeatures.setType(type);
				otherFeatures = otherFeatures.replace(type.getDescription(), "");
				annFeatures.setOtherFeatures(otherFeatures);
				break;
			}
		}
		annPieces = otherFeatures.split(",");
		for (String piece : annPieces) {
			price = getPrice(piece.split(" "));
			if (price != null) {
				String priceNum = Utilities.getOnlyNumbers(price);
				if(!priceNum.equals("")){
					other = price.replace(priceNum,"");
				if(other.contains("óôñ")){
					double dia = Double.parseDouble(priceNum)/1000.0;
					annFeatures.setPrice(dia);
				}else{
				annFeatures.setPrice(Double.parseDouble(priceNum));
				}
				otherFeatures = otherFeatures.replace(price, "");
				otherFeatures = otherFeatures.replace(AnnKeywords.TIMH, "");
				otherFeatures = otherFeatures.replace(AnnKeywords.EYRW, "");
				
				annFeatures.setOtherFeatures(otherFeatures);
				break;
				}
			}
		}
		annPieces = otherFeatures.split(",");
		for(String piece : annPieces){
			sxedio = getSxedio(piece.split(" "));
			if(sxedio != null){
				annFeatures.setInMap(sxedio);
				String[] outText = sxedio.split(" ");
				for(String out : outText){
					otherFeatures = otherFeatures.replace(out, "");
				}
				annFeatures.setOtherFeatures(otherFeatures);
				break;
			}
		}
		annPieces = otherFeatures.split(" ");
		embadon = getEmbadon(annPieces);
		if(embadon !=null){
			otherFeatures = otherFeatures.replace(embadon.getStringFormat(),"");
			annFeatures.setEmbadon(embadon);
			annFeatures.setOtherFeatures(otherFeatures);
			if(other!=null && (other.contains("/") || other.contains("ôï") )&& annFeatures.getPrice()!= null){
				Double synolikhTimh = annFeatures.getPrice();
				annFeatures.setPrice(synolikhTimh*embadon.getDoubleFormat());
			}
		}

		
		otherFeatures = annFeatures.getOtherFeatures();
		otherFeatures = otherFeatures.replace(", ,","");
		otherFeatures = otherFeatures.replace(",  ,","");
		otherFeatures = otherFeatures.replace(" ,   , ","");
		otherFeatures = otherFeatures.replace(" ,    ,","");
		otherFeatures = otherFeatures.replace("()","");
		
		char[] characters = otherFeatures.toCharArray();
		int i =0;
		int j = characters.length-1;
		while((i<characters.length) && (Character.isWhitespace(characters[i])|| (characters[i] ==',') || (characters[i]=='-'))){
			i++;
		}
		while((j>=0)&& (Character.isWhitespace(characters[j])|| (characters[j] ==',') || (characters[j]=='-'))){
			j--;
		}if(j<=0){
			otherFeatures = "";
		}else{
		otherFeatures = otherFeatures.substring(i,j);
		} 
        annFeatures.setOtherFeatures(otherFeatures);
	}


	protected String getSxedio(String[] text){
		String sxedio = null;
		for(int i=0;i<text.length;i++){
			String txt = text[i].trim();
			if(txt.equals(AnnKeywords.ENTOS) || txt.equals(AnnKeywords.EKTOS)){
				if(i+1<text.length){
					String tempTxt = text[i+1].trim();
					if(tempTxt.equals(AnnKeywords.SXEDIOY)){
						if(sxedio == null){
							sxedio = txt+" "+AnnKeywords.SXEDIOY;
						}else{
							sxedio += " "+txt+" "+AnnKeywords.SXEDIOY;
						}
					}
				}
			}
		}
		return sxedio;
	}

	protected void setAreas(String areaPiece) {
		super.setAreas(areaPiece);
		annFeatures.setMainAreaType(mainAreaType);
		if (secondArea != null) {
			annFeatures.setSecArea(secondArea);
		}
		String otherFeatures = annFeatures.getOtherFeatures();
		otherFeatures = otherFeatures.replace(mainAreaType.getDescription(), "");
		if(secondArea != null){
		otherFeatures = otherFeatures.replace(secondArea, "");
		}
		annFeatures.setOtherFeatures(otherFeatures);
	}

	public PlotSellingAnnouncement getAnnFeatures() {
		return annFeatures;
	}

	public void setAnnFeatures(PlotSellingAnnouncement annFeatures) {
		this.annFeatures = annFeatures;
	}

}
