package crawling;

public class WordUtilities {


	public static String turnIntoSuitableForm(String w) {
		w = WordUtilities.turnInToTotalCaps(w);
		String[] words = w.split(" ");
		if (words.length >= 2) {
			if (words[0].startsWith("ÁÃ") || words[0].equals("ÁÃ.")) {
				words[0] = "ÁÃ.";
				w = "";
				for (String word : words) {
					w += word;
				}
				w = w.substring(0, w.length());
			} else if (words[0].startsWith("ÍÅ") || words[0].equals("Í.")) {
				words[0] = "Í.";
				w = "";
				for (String word : words) {
					w += word;
				}
				w = w.substring(0, w.length());
			} else if (words[0].startsWith("ÁÍÙ") || words[0].equals("Á.")) {
				words[0] = "ÁÍÙ ";
				w = "";
				for (String word : words) {
					w += word;
				}
				w = w.substring(0, w.length());
			} else if (words[0].startsWith("ÊÁÔÙ") || words[0].equals("Ê.")) {
				words[0] = "ÊÁÔÙ ";
				w = "";
				for (String word : words) {
					w += word;
				}
				w = w.substring(0, w.length());
			} else if (words[0].startsWith("ÐÁËÁÉÏ") || words[0].equals("Ð.")) {
				words[0] = "ÐÁË.";
				w = "";
				for (String word : words) {
					w += word;
				}
				w = w.substring(0, w.length());
			} else if (words[0].startsWith("ÐËÁÔÅÉÁ") || words[0].equals("ÐË.")) {
				words[0] = "ÐË.";
				w = "";
				for (String word : words) {
					w += word;
				}
				w = w.substring(0, w.length());
			}
		}
		return w;
	}

	/**
	 * Given two words returns the number of letters that makes them differ.It
	 * gives the distance between two words
	 * 
	 * @param firstWord
	 * @param secondWord
	 * @return the distance between two words
	 */
	public static int findDistance(String firstWord, String secondWord) {
		int distance = 0;
		char[] firstChars = firstWord.toCharArray();
		char[] secondChars = secondWord.toCharArray();
		int firstLength = firstChars.length;
		int secondLength = secondChars.length;
		int commonLength = 0;
		int diafora = firstLength - secondLength;
		if (diafora < 0) {
			commonLength = firstLength;
		} else {
			commonLength = secondLength;
		}
		for (int i = 0; i < commonLength; i++) {
			if (firstChars[i] != secondChars[i]
					&& !isTheSameLetterInLatin(firstChars[i], secondChars[i])) {
				distance++;
			}
		}
		if (diafora < 0) {
			return distance - diafora;
		}
		return distance + diafora;
	}

	
	/**
	 * Find distance in a way that trying compute it has sense only if their common length is up or equal to 7 
	 * and the length of two words differ maximum 3 characters. This function start to count distance without take
	 * in consideration the ending the word.
	 * @param firstWord
	 * @param secondWord
	 * @return distance without take in consideration the ending  of the word. It returns 100 when there is no
	 * way for two these words to have even a common root
	 */
	public static int findEndDistance(String firstWord, String secondWord){
		int distance=0;
		char[] firstChars = firstWord.toCharArray();
		char[] secondChars = secondWord.toCharArray();
		int firstLength = firstChars.length;
		int secondLength = secondChars.length;
		int commonLength = 0;
		int diafora = firstLength-secondLength;
		if(diafora<0){
			commonLength = firstLength;
		}else{
			commonLength = secondLength;
		}
		if(commonLength<=7||firstWord.equals("ÁÉÃÉÏ")||firstWord.equals("ÁÉÃÉÍÁ")){
			return 100;
		}
		if(diafora==0){
			for(int i=0;i<commonLength-3;i++){
				if(firstChars[i]!=secondChars[i] && !isTheSameLetterInLatin(firstChars[i],secondChars[i])){
					distance++;
				}
			}
		}else if (diafora==1||diafora==-1){
			for(int i=0;i<commonLength-2;i++){
				if(firstChars[i]!=secondChars[i] && !isTheSameLetterInLatin(firstChars[i],secondChars[i])){
					distance++;
				}
			}
		}else if(diafora==2||diafora==-2){
			for(int i=0;i<commonLength-1;i++){
				if(firstChars[i]!=secondChars[i] && !isTheSameLetterInLatin(firstChars[i],secondChars[i])){
					distance++;
				}
			}
		}else if(diafora==3||diafora==-3){
			for(int i=0;i<commonLength;i++){
				if(firstChars[i]!=secondChars[i] && !isTheSameLetterInLatin(firstChars[i],secondChars[i])){
					distance++;
				}
			}
		}else{
		return 100;
		}
		return distance;
	}
	public static boolean isTheSameLetterInLatin(char ch1, char ch2) {
		if ((ch1 == 'A' && ch2 == 'Á') || (ch1 == 'Â' && ch2 == 'Â')
				|| (ch1 == 'E' && ch2 == 'Å') || (ch1 == 'H' && ch2 == 'Ç')
				|| (ch1 == 'I' && ch2 == 'É') || (ch1 == 'K' && ch2 == 'Ê')
				|| (ch1 == 'M' && ch2 == 'Ì') || (ch1 == 'N' && ch2 == 'Í')
				|| (ch1 == 'O' && ch2 == 'Ï') || (ch1 == 'P' && ch2 == 'Ñ')
				|| (ch1 == 'T' && ch2 == 'Ô') || (ch1 == 'X' && ch2 == '×')
				|| (ch1 == 'Y' && ch2 == 'Õ') || (ch1 == 'Z' && ch2 == 'Æ')
				|| (ch2 == 'A' && ch1 == 'Á') || (ch2 == 'Â' && ch1 == 'Â')
				|| (ch2 == 'E' && ch1 == 'Å') || (ch2 == 'H' && ch1 == 'Ç')
				|| (ch2 == 'I' && ch1 == 'É') || (ch2 == 'K' && ch1 == 'Ê')
				|| (ch2 == 'M' && ch1 == 'Ì') || (ch2 == 'N' && ch1 == 'Í')
				|| (ch2 == 'O' && ch1 == 'Ï') || (ch2 == 'P' && ch1 == 'Ñ')
				|| (ch2 == 'T' && ch1 == 'Ô') || (ch2 == 'X' && ch1 == '×')
				|| (ch2 == 'Y' && ch1 == 'Õ') || (ch2 == 'Z' && ch1 == 'Æ')) {
			return true;
		}
		return false;
	}

	public static String turnInToTotalCaps(String word) {
		word = word.toUpperCase();
		if (word.contains("¹")) {
			word = word.replace("¹", "Ç");
		}
		if (word.contains("¢")) {
			word = word.replace("¢", "Á");
		}
		if (word.contains("¸")) {
			word = word.replace("¸", "Å");
		}
		if (word.contains("¼")) {
			word = word.replace("¼", "Ï");
		}
		if (word.contains("º")) {
			word = word.replace("º", "É");
		}
		if (word.contains("¾")) {
			word = word.replace("¾", "Õ");
		}
		if (word.contains("¿")) {
			word = word.replace("¿", "Ù");
		}
		return word;
	}
	
	public static boolean findCommonRoot(String word1,String word2){
		if(word1.endsWith("ÇÓ")){
			String temp = word1.substring(0,word1.length()-2);
			temp+="ÉÏÓ";
			System.out.println("TEMP:"+temp+" WORD2:"+word2);
			if(temp.equals(word2)){
				return true;
			}
		}else if(word2.endsWith("ÇÓ")){
			String temp = word2.substring(0,word2.length()-2);
			temp+="ÉÏÓ";
			System.out.println("TEMP:"+temp+" WORD1:"+word1);
			if(temp.equals(word1)){
				return true;
			}
		}else if(word1.endsWith("Á")){
			String temp = word1.substring(0,word1.length()-1);
			temp+="ÙÍ";
			System.out.println("TEMP:"+temp+" WORD2:"+word2);
			if(temp.equals(word2)){
				return true;
			}
		}else if(word2.endsWith("Á")){
			String temp = word2.substring(0,word2.length()-1);
			temp+="ÙÍ";
			System.out.println("TEMP:"+temp+" WORD1:"+word1);
			if(temp.equals(word1)){
				return true;
			}
		}else if(word1.endsWith("ÏÉ")){
			String temp = word1.substring(0,word1.length()-2);
			temp+="ÙÍ";
			System.out.println("TEMP:"+temp+" WORD2:"+word2);
			if(temp.equals(word2)){
				return true;
			}
		}else if(word2.endsWith("ÏÉ")){
			String temp = word2.substring(0,word2.length()-2);
			temp+="ÙÍ";
			System.out.println("TEMP:"+temp+" WORD1:"+word1);
			if(temp.equals(word1)){
				return true;
			}
		}else if(word1.endsWith("Ç")){
			String temp = word1.substring(0,word1.length()-1);
			temp+="ÅÙÓ";
			System.out.println("TEMP:"+temp+" WORD2:"+word2);
			if(temp.equals(word2)){
				return true;
			}
		}else if(word2.endsWith("Ç")){
			String temp = word2.substring(0,word2.length()-1);
			temp+="ÅÙÓ";
			System.out.println("TEMP:"+temp+" WORD1:"+word1);
			if(temp.equals(word1)){
				return true;
			}
		}else if(word1.endsWith("Á")){
			String temp = word1.substring(0,word1.length()-1);
			temp+="ÇÓ";
			System.out.println("TEMP:"+temp+" WORD2:"+word2);
			if(temp.equals(word2)){
				return true;
			}
		}else if(word2.endsWith("Á")){
			String temp = word2.substring(0,word2.length()-1);
			temp+="ÏÓ";
			System.out.println("TEMP:"+temp+" WORD1:"+word1);
			if(temp.equals(word1)){
				return true;
			}
		}else if(word1.endsWith("ÅÉÏ")){
			String temp = word1.substring(0,word1.length()-3);
			temp+="ÏÕ";
			System.out.println("TEMP:"+temp+" WORD2:"+word2);
			if(temp.equals(word2)){
				return true;
			}
		}else if(word2.endsWith("ÅÉÏ")){
			String temp = word2.substring(0,word2.length()-3);
			temp+="ÏÕ";
			System.out.println("TEMP:"+temp+" WORD1:"+word1);
			if(temp.equals(word1)){
				return true;
			}
		}else if(word1.endsWith("Ç")){
			String temp = word1.substring(0,word1.length()-1);
			temp+="ÉÁ";
			System.out.println("TEMP:"+temp+" WORD2:"+word2);
			if(temp.equals(word2)){
				return true;
			}
		}else if(word2.endsWith("Ç")){
			String temp = word2.substring(0,word2.length()-1);
			temp+="ÉÁ";
			System.out.println("TEMP:"+temp+" WORD1:"+word1);
			if(temp.equals(word1)){
				return true;
			}
		}else if(word1.endsWith("ÅÓ")){
			String temp = word1.substring(0,word1.length()-1);
			temp+="ÙÍ";
			System.out.println("TEMP:"+temp+" WORD2:"+word2);
			if(temp.equals(word2)){
				return true;
			}
		}else if(word2.endsWith("ÅÓ")){
			String temp = word2.substring(0,word2.length()-1);
			temp+="ÙÍ";
			System.out.println("TEMP:"+temp+" WORD1:"+word1);
			if(temp.equals(word1)){
				return true;
			}
		}
		return false;
	}
}
