/**
 * class AggelAdvertisements
 * 
 * Miren Arizaleta Arteaga
 * Athens, February 2011
 */
package crawling.aggel;

import java.sql.Connection;
import java.sql.DriverManager;
import java.util.ArrayList;
import java.util.Observable;
import java.util.Properties;

//import javax.swing.JTextArea;
//import crawling.crawl;
import crawling.AnnKeywords;
import crawling.ReadSource;
import crawling.Utilities;
import crawling.database.DatabaseUpdateManager;
import crawling.entities.Announcement;
import crawling.entities.HouseAnnouncement;
import crawling.entities.IdDescription;
import crawling.entities.PlotSellingAnnouncement;
import crawling.entities.SearchInfo;

public class AggelAdvertisements  {

	private Connection connection;

	private final static String AGGEL_MAIN_URL = "http://www.aggelioxoros.gr/aggelies/_house.htm";

	private final static String AGGEL_URL = "http://www.aggelioxoros.gr/aggelies/";

	/*************************************TAGS******************************************* */
	//The begining of the link for found all the advertisements
	private final static String URL_TAG = "<p class=\"hypcat\"><a href=";
	//The end of the link for found all the advertisements
	private final static String URL_END_TAG = "</a></p>";
	//The begining of the link for each advertisement
	private final static String ADV_START_TAG = "<p class=\"p1";
	//The end of the link for each advertisement
	private final static String ADV_END_TAG = "</p>";
	/*************************************TAGS******************************************* */
	//Constructor of AggelAdvertisements
	public AggelAdvertisements() {
		System.out.println("\t \t \t **************************************************");
		System.out.println(" \t\t\t *\t\tStarting Aggelioxoros             *");
		System.out.println("\t \t \t **************************************************");
		if(openMySQLConnection()){
			System.out.println("\t\t\t\t       Connected To Database ");
			
		init();
		}else{
			System.out.println("Can not open a connection to database");
		}
	}

	/**
	 * Opens a connection with the mysql connection of ptyxiakh database
	 */
	private boolean openMySQLConnection() {
		try {
			Class.forName("com.mysql.jdbc.Driver");
			Properties props = new Properties();
			props.put("user", "root");
			props.put("password", "");
		    props.put("useUnicode", "true");
			props.put("characterEncoding", "utf-8");
			connection = DriverManager.getConnection("jdbc:mysql://localhost:3306/temp09062009", props);
			//connection = DriverManager.getConnection("jdbc:mysql://localhost/temp09062009", props);
			

			return true;
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println("ERROR: Failed to get connection to database!");
			return false;
		}
	}
	public  void init()  {
		//For reading all the code of the url
		ReadSource scr = new ReadSource(AGGEL_MAIN_URL,AnnKeywords.AGGELIOXWROS);
		String mainPageSource = scr.getSource();

	    ArrayList<String> texts = Utilities.extractAllTexts(mainPageSource,URL_TAG,URL_END_TAG);	

	    //For each url in aggelioxoros
		for(String text:texts)
		{   SearchInfo searchInfo = new SearchInfo();
		    System.out.println(text);
			searchInfo.setSourceId(AnnKeywords.AGGELIOXWROS);
			searchInfo.setDate(new java.sql.Date(System.currentTimeMillis()));
			//Code for check the type of the advertisement
			if((text.contains("Ενοικιάσεις Κατοικιών")||text.contains("Ενοικιάσεις Εποχικές")||text.contains("Συγκάτοικοι"))&&!(text.contains("Ζητήσεις"))){
				//This kind of advertisement is for rent houses
				searchInfo.setOffer(1);
				System.out.println("RENT_HOUSE");
				editRentHouses(text,searchInfo);
			}
			if((text.contains("Πωλήσεις Κατοικιών")||text.contains("Πωλήσεις Εξοχικών Κατοικιών"))&&!(text.contains("Ζητήσεις"))){
				//This kind of advertisement is for sell houses
				searchInfo.setSold(true);
				System.out.println("SELL_HOUSE");
				editSellHouses(text,searchInfo);
				
			}
			if((text.contains("Πωλήσεις Οικοπέδων"))&&!(text.contains("Ζητήσεις"))){
				//This kind of advertisement is for sell earth
				searchInfo.setSold(true);
				System.out.println("SELL_EARTH");
				editSellEarth(text,searchInfo);
			}
			
		}
		System.out.println("**************** Finished Aggelioxwros ****************");
	}

	public void  editRentHouses(String text, SearchInfo searchInfo){
		String url = text.substring(0,text.indexOf(">")).replace("\"","");
		url=AGGEL_URL+url;
	    //System.out.println(url);
		searchInfo.setCategory(new IdDescription(AnnKeywords.RENT_HOUSE_CODE,AnnKeywords.ENOIKIASEIS_KATOIKIWN));
		searchInfo = editSearchInfo(text,searchInfo);
		ArrayList<String> advs = extractAdvertisements(url);
		advs = Utilities.getManyInOneAnnTexts(advs);
		ArrayList<HouseAnnouncement> houses = new ArrayList<HouseAnnouncement>(0);
		for(String adv:advs){
			System.out.println("Rent House Advertisment :"+adv);
			AggelHouseFeatExtraction house = new AggelHouseFeatExtraction(0,adv,connection,searchInfo);
			HouseAnnouncement houseFeat = house.getHouseAnnouncement();
			houses.add(houseFeat);
			SearchInfo searchInf = house.getSearchInfo();
			int searchId=DatabaseUpdateManager.updateSearchTable(searchInf,connection);
			if(houseFeat.getPrice()!=null && houseFeat.getPrice() <10000){
try{
DatabaseUpdateManager.updateHouseAnnTable(new Announcement(),houseFeat,searchId,AnnKeywords.RENT_HOUSE_CODE,connection);
System.out.println("Ginetai UPDATE");
}
catch (Exception ex){
	System.out.println("hello");
}

			}
			
		}
		
	}
	
	public void editSellEarth(String text,SearchInfo searchInfo){
		String url = text.substring(0,text.indexOf(">")).replace("\"","");
		url=AGGEL_URL+url;
	    //System.out.println(url);
		searchInfo.setCategory(new IdDescription(AnnKeywords.SELL_EARTH_CODE,AnnKeywords.PWLHSEIS_OIKOPEDWN));
		searchInfo = editSearchInfo(text,searchInfo);
		ArrayList<String> advs = extractAdvertisements(url);	
		advs = Utilities.getManyInOneAnnTexts(advs);
		ArrayList<PlotSellingAnnouncement> plots = new ArrayList<PlotSellingAnnouncement>(0);
		for(String adv:advs){
			System.out.println("Sell Earth Advertisment :"+adv);
			AggelEarthFeatExtraction earth = new AggelEarthFeatExtraction(0,adv,connection,searchInfo);
			PlotSellingAnnouncement plot = earth.getPlotAnnouncement();
			plots.add(plot);
			SearchInfo searchInf = earth.getSearchInfo();
			int searchId=DatabaseUpdateManager.updateSearchTable(searchInf,connection);
			DatabaseUpdateManager.updateSellEarthAnnTable(new Announcement(),plot,searchId,connection);
		}
	}
	public void editSellHouses(String text, SearchInfo searchInfo)
	{
		String url = text.substring(0,text.indexOf(">")).replace("\"","");
		url=AGGEL_URL+url;
	    //System.out.println(url);
		searchInfo.setCategory(new IdDescription(AnnKeywords.SELL_HOUSE_CODE,AnnKeywords.PWLHSEIS_KATOIKIWN));
		searchInfo = editSearchInfo(text,searchInfo);
		ArrayList<String> advs = extractAdvertisements(url);
		advs = Utilities.getManyInOneAnnTexts(advs);
		ArrayList<HouseAnnouncement> houses = new ArrayList<HouseAnnouncement>(0);
		for(String adv:advs){
			System.out.println("Sell House Advertisment :"+adv);
			AggelHouseFeatExtraction house = new AggelHouseFeatExtraction(0,adv,connection,searchInfo);
			HouseAnnouncement houseFeat = house.getHouseAnnouncement();
			houses.add(houseFeat);
			SearchInfo searchInf = house.getSearchInfo();
			int searchId=DatabaseUpdateManager.updateSearchTable(searchInf,connection);
			DatabaseUpdateManager.updateHouseAnnTable(new Announcement(),houseFeat,searchId,AnnKeywords.SELL_HOUSE_CODE,connection);
		}
	}
	
	private SearchInfo editSearchInfo(String text,SearchInfo searchInfo){
		if(text.contains(AnnKeywords.THESSALONIKH)||
				 text.contains(AnnKeywords.AG_PARASKEBHS)||
				 text.contains(AnnKeywords.PERIXWRA)||
				 text.contains(AnnKeywords.PERAIA)){
			searchInfo.setDiamerisma(new IdDescription(AnnKeywords.MAKEDONIA_ID));
			searchInfo.setNomos(new IdDescription(AnnKeywords.THESSALONIKH_ID));
		 }
		if(text.contains(AnnKeywords.MAKEDONIA_THRAKH)){
			IdDescription temp = new IdDescription();
			temp.setDescription(AnnKeywords.MAKEDONIA_THRAKH);
			searchInfo.setDiamerisma(temp);
		}
		if(text.contains(AnnKeywords.HPEIRO_THESSALIA_STELLADA)){
			IdDescription temp = new IdDescription();
			temp.setDescription(AnnKeywords.HPEIRO_THESSALIA_STELLADA);
			searchInfo.setDiamerisma(temp);
		}
		if(text.contains(AnnKeywords.NHSIA)){
			IdDescription temp = new IdDescription();
			temp.setDescription(AnnKeywords.NHSIA);
			searchInfo.setDiamerisma(temp);
		}
		if(text.contains(AnnKeywords.ATTIKH)){
			searchInfo.setDiamerisma(new IdDescription(AnnKeywords.STELLADA_BEYBOIA_ID));
			searchInfo.setNomos(new IdDescription(AnnKeywords.ATTIKH_ID));
		}
		 
	   return searchInfo;	
	}
	

	
	private ArrayList<String> extractAdvertisements(String url){
		ReadSource readSource = new ReadSource(url,AnnKeywords.AGGELIOXWROS);
		String source = readSource.getSource();
		ArrayList<String> advertisements = Utilities.extractAllTexts(source,ADV_START_TAG,ADV_END_TAG);
		for(String adv:advertisements){
			adv=adv.substring(2);
			//System.out.println("ADV:"+adv);
		}
		return advertisements;
	}
	
	public static void main(String[] args){
		
		AggelAdvertisements adv = new AggelAdvertisements();
	}


}
