/**
 * class AggelEarthFeatExtraction
 * @author Dimitra Xidara
 */
package crawling.aggel;

import java.sql.Connection;
import java.util.ArrayList;

import crawling.AnnKeywords;
import crawling.Utilities;
import crawling.database.DatabaseSelectManager;
import crawling.entities.DoubleStringFormat;
import crawling.entities.IdDescription;
import crawling.entities.PlotSellingAnnouncement;
import crawling.entities.SearchInfo;
import crawling.*;
public class AggelEarthFeatExtraction extends AggelFeatExtraction{

	private PlotSellingAnnouncement plotAnnouncement;
	
	public AggelEarthFeatExtraction(int nomosId, String announcement, Connection connection,SearchInfo searchInfo) {
		super(nomosId, announcement, connection,searchInfo);
		plotAnnouncement = new PlotSellingAnnouncement();
		editAnnFeatures();
	}

	@Override
	protected void editAnnFeatures() {
		super.editAnnFeatures();
		plotAnnouncement.setMainAreaType(mainAreaType);
		plotAnnouncement.setSecArea(secondArea);
	    DoubleStringFormat embadon = getEmbadon(announcement.split(" "));
	    if(embadon!=null){
	    	plotAnnouncement.setEmbadon(embadon);
	    	announcement = announcement.replace(embadon.getStringFormat(),"");
	    }

	    ArrayList<IdDescription> types = DatabaseSelectManager.getTypesOfEarth(getConnection());
	    IdDescription type = getType(announcement.split(" "),types);
	    if(type!=null){
	    	plotAnnouncement.setType(type);
	    }
	    plotAnnouncement.setPhones(getPhones());	   
	    
	    String price = getPrice(announcement.split(" "));
	    if(!price.equals("")){
	    	double priceDouble = Utilities.toNumber(price);
	    	if(priceDouble<1000000000){
	    	plotAnnouncement.setPrice(Utilities.toNumber(price));
	    	announcement = announcement.replace(price,"");
	    	}
	    }
	    String inMap = getSxedio(announcement.split(" "));
	    if(inMap!=null){
	    plotAnnouncement.setInMap(inMap);
	    }
	    plotAnnouncement.setOtherFeatures(announcement);
	}
	
	
	protected IdDescription getType(String[] text, ArrayList<IdDescription> types) {
		for(int i=0;i<text.length;i++){
			if(text[i].equals(AnnKeywords.OIKOPXWRIS)||
					text[i].equals(AnnKeywords.OIKOP)||
					text[i].equals(AnnKeywords.OIKOPEDOY)||
					text[i].equals(AnnKeywords.OIKOPEDO)||
					text[i].equals(AnnKeywords.OIKOPEDA)||
					text[i].equals(AnnKeywords.OIKOPEDO_L)){
				announcement=announcement.replace(text[i],"");
				text[i]=AnnKeywords.OIKOPEDO;
			}else if(text[i].equals(AnnKeywords.AGROTEMAXEIO)||
					text[i].equals(AnnKeywords.AGROTEMAXIA)||
					text[i].equals(AnnKeywords.AGROTEMAXIO)||
					text[i].equals(AnnKeywords.AGROTEMAXIO_XWRIS)){
				announcement=announcement.replace(text[i],"");
				text[i]=AnnKeywords.AGROTEMAXIO;
			}else if(text[i].equals(AnnKeywords.XWRAFI)||
					text[i].equals(AnnKeywords.XWRAFIA)){
				announcement=announcement.replace(text[i],"");
				text[i]=AnnKeywords.XWRAFI;
				
			}else if(text[i].equals(AnnKeywords.AGROS)){
				announcement=announcement.replace(text[i],"");
				text[i]=AnnKeywords.AGROS;
			}else if(text[i].equals(AnnKeywords.AMPELI)){
				announcement=announcement.replace(text[i],"");
				text[i]=AnnKeywords.AMPELI;
			}
		}
		return super.getType(text, types);
	}
//	protected String getSxedio(String[] text){
//		String sxedio = null;
//		for(int i=0;i<text.length;i++){
//			String txt = text[i].trim();
//			if(txt.equals(AnnKeywords.ENTOS) || txt.equals(AnnKeywords.EKTOS)){
//				if(i+1<text.length){
//					String tempTxt = text[i+1].trim();
//					if(tempTxt.equals(AnnKeywords.SXEDIOY)){
//						if(sxedio == null){
//							sxedio = txt+" "+AnnKeywords.SXEDIOY;
//							announcement = announcement.replace(sxedio,"");
//						}else{
//							sxedio += " "+txt+" "+AnnKeywords.SXEDIOY;
//						}
//						announcement = announcement.replace(sxedio,"");
//						announcement = announcement.replace(sxedio,"");
//					}
//				}
//			}
//		}
//		return sxedio;
//	}
	public PlotSellingAnnouncement getPlotAnnouncement() {
		return plotAnnouncement;
	}

	public void setPlotAnnouncement(PlotSellingAnnouncement plotAnnouncement) {
		this.plotAnnouncement = plotAnnouncement;
	}
}
