package crawling.database;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

import crawling.AnnKeywords;

public class DatabaseDeleteManager {

	public static void deleteAnnHousesRecords(ArrayList<Integer> annHouseIds,
			Connection connection) {
		Statement stmt = null;
		if (annHouseIds != null && annHouseIds.size() > 0) {
			String query = "DELETE FROM ann_house WHERE ANID="
					+ annHouseIds.get(0);
			for (int i = 1; i < annHouseIds.size(); i++) {
				query += " OR ANID=" + annHouseIds.get(i);
			}
			try {
				stmt = connection.createStatement();
				stmt.executeUpdate(query);
			} catch (SQLException ex) {
				ex.printStackTrace();
			} finally {
				if (stmt != null) {
					try {
						stmt.close();
					} catch (SQLException ex) {
						ex.printStackTrace();
						System.out.println("Error in closing statement");
					}
				}
			}
		}
	}

	public static void deleteAnnHousesRecord(int id, Connection connection) {
		Statement stmt = null;
		String query = "DELETE FROM ann_house WHERE ANID=" + id;
		try {
			stmt = connection.createStatement();
			stmt.executeUpdate(query);
		} catch (SQLException ex) {
			ex.printStackTrace();
		} finally {
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException ex) {
					ex.printStackTrace();
					System.out.println("Error in closing statement");
				}
			}
		}
	}

	public static void deleteAuctionRecord(int id, Connection connection) {
		Statement stmt = null;
		String query = "DELETE FROM ann_auction WHERE ANID=" + id;
		try {
			stmt = connection.createStatement();
			stmt.executeUpdate(query);
		} catch (SQLException ex) {
			ex.printStackTrace();
		} finally {
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException ex) {
					ex.printStackTrace();
					System.out.println("Error in closing statement");
				}
			}
		}
	}

	public static void deleteAnnSellEarthRecords(
			ArrayList<Integer> annSellEarthIds, Connection connection) {
		Statement stmt = null;
		if (annSellEarthIds != null && annSellEarthIds.size() > 0) {
			String query = "DELETE FROM ann_sell_earth WHERE ANID="
					+ annSellEarthIds.get(0);
			for (int i = 1; i < annSellEarthIds.size(); i++) {
				query += " OR ANID=" + annSellEarthIds.get(i);
			}
			if (annSellEarthIds.size() > 0) {
				try {
					stmt = connection.createStatement();
					stmt.executeUpdate(query);
				} catch (SQLException ex) {
					ex.printStackTrace();
				} finally {
					if (stmt != null) {
						try {
							stmt.close();
						} catch (SQLException ex) {
							ex.printStackTrace();
							System.out.println("Error in closing statement");
						}
					}
				}
			}
		}
	}

	public static void deleteAnnSellEarthRecord(int id, Connection connection) {
		Statement stmt = null;
		String query = "DELETE FROM ann_sell_earth WHERE ANID=" + id;
		try {
			stmt = connection.createStatement();
			stmt.executeUpdate(query);
		} catch (SQLException ex) {
			ex.printStackTrace();
		} finally {
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException ex) {
					ex.printStackTrace();
					System.out.println("Error in closing statement");
				}
			}
		}
	}

	public static void deleteOrofosRecords(ArrayList<Integer> annHouseIds,
			Connection connection) {
		Statement stmt = null;
		if (annHouseIds != null && annHouseIds.size() > 0) {
			String query = "DELETE FROM ann_orofos WHERE ANID="
					+ annHouseIds.get(0);
			for (int i = 1; i < annHouseIds.size(); i++) {
				query += " OR ANID=" + annHouseIds.get(i);
			}
			try {
				stmt = connection.createStatement();
				stmt.executeUpdate(query);
			} catch (SQLException ex) {
				ex.printStackTrace();
			} finally {
				if (stmt != null) {
					try {
						stmt.close();
					} catch (SQLException ex) {
						ex.printStackTrace();
						System.out.println("Error in closing statement");
					}
				}
			}
		}
	}

	public static void deleteOrofosRecord(int id, Connection connection) {
		Statement stmt = null;
		String query = "DELETE FROM ann_orofos WHERE ANID=" + id;
		try {
			stmt = connection.createStatement();
			stmt.executeUpdate(query);
		} catch (SQLException ex) {
			ex.printStackTrace();
		} finally {
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException ex) {
					ex.printStackTrace();
					System.out.println("Error in closing statement");
				}
			}
		}
	}

	public static void deletePeriodsRecord(int id, int category,
			Connection connection) {
		Statement stmt = null;
		String query;
		if (category == AnnKeywords.SELL_EARTH_CODE) {
			query = "DELETE FROM ann_period WHERE AN_TYPE="
					+ AnnKeywords.SELL_EARTH_CODE + " AND (ANID=" + id + ")";
		} else {
			query = "DELETE FROM ann_period WHERE (AN_TYPE="
					+ AnnKeywords.SELL_HOUSE_CODE + " OR AN_TYPE="
					+ AnnKeywords.RENT_HOUSE_CODE + ") AND(ANID=" + id + ")";
		}
		try {
			stmt = connection.createStatement();
			stmt.executeUpdate(query);
		} catch (SQLException ex) {
			ex.printStackTrace();
		} finally {
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException ex) {
					ex.printStackTrace();
					System.out.println("Error in closing statement");
				}
			}
		}
	}

	public static void deletePeriodsRecords(ArrayList<Integer> annHouseIds,
			int category, Connection connection) {
		Statement stmt = null;
		String query;
		if (annHouseIds != null && annHouseIds.size() > 0) {
			if (category == AnnKeywords.SELL_EARTH_CODE) {
				query = "DELETE FROM ann_period WHERE AN_TYPE="
						+ AnnKeywords.SELL_EARTH_CODE + " AND (ANID="
						+ annHouseIds.get(0);
			} else {
				query = "DELETE FROM ann_period WHERE (AN_TYPE="
						+ AnnKeywords.SELL_HOUSE_CODE + " OR AN_TYPE="
						+ AnnKeywords.RENT_HOUSE_CODE + ") AND(ANID="
						+ annHouseIds.get(0);
			}
			for (int i = 1; i < annHouseIds.size(); i++) {
				query += " OR ANID=" + annHouseIds.get(i);
			}
			query += ")";
			try {
				stmt = connection.createStatement();
				stmt.executeUpdate(query);
			} catch (SQLException ex) {
				ex.printStackTrace();
			} finally {
				if (stmt != null) {
					try {
						stmt.close();
					} catch (SQLException ex) {
						ex.printStackTrace();
						System.out.println("Error in closing statement");
					}
				}
			}
		}
	}
	public static void deletePhonesRecord(int id,
			int category, Connection connection) {
		Statement stmt = null;
		String query;
			if (category == AnnKeywords.SELL_EARTH_CODE) {
				query = "DELETE FROM ann_phones WHERE AN_TYPE="
						+ AnnKeywords.SELL_EARTH_CODE + " AND (ANID="
						+ id+")";
			} else {
				query = "DELETE FROM ann_phones WHERE (AN_TYPE="
						+ AnnKeywords.SELL_HOUSE_CODE + " OR AN_TYPE="
						+ AnnKeywords.RENT_HOUSE_CODE + ") AND (ANID="
						+ id+")";
			}
			try {
				stmt = connection.createStatement();
				stmt.executeUpdate(query);
			} catch (SQLException ex) {
				ex.printStackTrace();
			} finally {
				if (stmt != null) {
					try {
						stmt.close();
					} catch (SQLException ex) {
						ex.printStackTrace();
						System.out.println("Error in closing statement");
					}
				}
			}
		
	}
	public static void deletePhonesRecords(ArrayList<Integer> annHouseIds,
			int category, Connection connection) {
		Statement stmt = null;
		String query;
		if (annHouseIds != null && annHouseIds.size() > 0) {
			if (category == AnnKeywords.SELL_EARTH_CODE) {
				query = "DELETE FROM ann_phones WHERE AN_TYPE="
						+ AnnKeywords.SELL_EARTH_CODE + " AND (ANID="
						+ annHouseIds.get(0);
			} else {
				query = "DELETE FROM ann_phones WHERE (AN_TYPE="
						+ AnnKeywords.SELL_HOUSE_CODE + " OR AN_TYPE="
						+ AnnKeywords.RENT_HOUSE_CODE + ") AND (ANID="
						+ annHouseIds.get(0);
			}
			for (int i = 1; i < annHouseIds.size(); i++) {
				query += " OR ANID=" + annHouseIds.get(i);
			}
			query += ")";
			try {
				stmt = connection.createStatement();
				stmt.executeUpdate(query);
			} catch (SQLException ex) {
				ex.printStackTrace();
			} finally {
				if (stmt != null) {
					try {
						stmt.close();
					} catch (SQLException ex) {
						ex.printStackTrace();
						System.out.println("Error in closing statement");
					}
				}
			}
		}
	}

	public static void deletePerioxesRecords(ArrayList<Integer> perioxesId,
			Connection connection) {
		Statement stmt = null;
		if (perioxesId != null && perioxesId.size() > 0) {
			String query = "DELETE FROM geo_perioxes WHERE ID="
					+ perioxesId.get(0);
			for (int i = 1; i < perioxesId.size(); i++) {
				query += " OR ID=" + perioxesId.get(i);
			}
			try {
				stmt = connection.createStatement();
				stmt.executeUpdate(query);
			} catch (SQLException ex) {
				ex.printStackTrace();
			} finally {
				if (stmt != null) {
					try {
						stmt.close();
					} catch (SQLException ex) {
						ex.printStackTrace();
						System.out.println("Error in closing statement");
					}
				}
			}
		}
	}

	public static void deleteAreaRecords(int perioxhId, Connection connection) {
		Statement stmt = null;
		String query = "DELETE FROM geo_perioxes WHERE ID=" + perioxhId;
		try {
			stmt = connection.createStatement();
			stmt.executeUpdate(query);
		} catch (SQLException ex) {
			ex.printStackTrace();
		} finally {
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException ex) {
					ex.printStackTrace();
					System.out.println("Error in closing statement");
				}
			}
		}
	}
	public static void deleteCooRecords(int cooId, Connection connection) {
		Statement stmt = null;
		String query = "DELETE FROM ann_cooperator WHERE ID=" + cooId;
		try {
			stmt = connection.createStatement();
			stmt.executeUpdate(query);
		} catch (SQLException ex) {
			ex.printStackTrace();
		} finally {
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException ex) {
					ex.printStackTrace();
					System.out.println("Error in closing statement");
				}
			}
		}
	}
}
