package crawling.database;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

import crawling.AnnKeywords;
import crawling.entities.Auction;
import crawling.entities.DoubleStringFormat;
import crawling.entities.HouseAnnouncement;
import crawling.entities.IdDescription;
import crawling.entities.PlotSellingAnnouncement;

public class DatabaseManager {
	
	public static boolean isCooperatorAlreadyIn(IdDescription cooperator, int type,Connection connection){
		Statement stmt = null;
		ResultSet rset = null;
		Integer sum=0;
		try {
			stmt = connection.createStatement();
			String query = "SELECT COUNT(*) AS SUM FROM ann_cooperator WHERE COO_TYPE="+type+ " AND NAME='"+cooperator.getDescription()+"'";
			rset = stmt.executeQuery(query);
			while (rset.next()) {
				sum= rset.getInt("SUM");
			}
		} catch (SQLException ex) {
			ex.printStackTrace();
		} finally {
			if (rset != null) {
				try {
					rset.close();
				} catch (SQLException ex) {
					ex.printStackTrace();
					System.out.println("\nError in closing result set");
				}
			}
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException ex) {
					ex.printStackTrace();
					System.out.println("\nError in closing statement");
				}
			}
			if(sum!=0){
				return true;
			}
		}
		return false;
	}
	public static boolean isPerioxhAlreadyIn(IdDescription perioxh, int nomosId,Connection connection){
		Statement stmt = null;
		ResultSet rset = null;
		Integer sum = 0;
		try {
			stmt = connection.createStatement();
//			System.out.println("DESCRIPTION:"+perioxh.getDescription());
			String query = "SELECT COUNT(*) AS SUM FROM geo_perioxes WHERE NOMOS_ID="+nomosId+ " AND DESCRIPTION='"+perioxh.getDescription()+"'";
			System.out.println("SELECT COUNT(*) AS SUM FROM geo_perioxes WHERE NOMOS_ID="+nomosId+ " AND DESCRIPTION='"+perioxh.getDescription()+"'");
			rset = stmt.executeQuery(query);
			while (rset.next()) {
				sum= rset.getInt("SUM");
			}
		} catch (SQLException ex) {
			ex.printStackTrace();
		} finally {
			if (rset != null) {
				try {
					rset.close();
				} catch (SQLException ex) {
					ex.printStackTrace();
					System.out.println("\nError in closing result set");
				}
			}
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException ex) {
					ex.printStackTrace();
					System.out.println("\nError in closing statement");
				}
			}
			if(sum!=0){
				return true;
			}
		}
		return false;
	}
	
	@SuppressWarnings("finally")
	public static boolean isEarthAnnAlreadyIn(
			int isOffer, int sourceId,PlotSellingAnnouncement plot,Connection connection) {
		Statement stmt = null;
		ResultSet rset = null;
		Integer sum =0;
		/*******************in case some are null**********************************/
		String secondArea="";
		String inmap="";
		String price=null;
		String coo_id=null;
		String embadon = null;
		if(plot.getSecArea()!=null){
			secondArea=" AND SECONDAREA='"+plot.getSecArea()+"'";
		}else{
			secondArea=" AND SECONDAREA IS NULL ";
		}
		if(plot.getInMap()!=null){
			inmap=" AND INMAP='"+plot.getInMap()+"'";
		}else{
			inmap=" AND INMAP IS NULL ";
		}
		if(plot.getPrice()!=null){
			price = " AND PRICE="+plot.getPrice();
		}else{
			price = " AND PRICE IS NULL ";
		}
		if(plot.getCoo_id()!=null){
			coo_id = " AND COO_ID="+plot.getCoo_id();
		}else{
			coo_id = " AND COO_ID IS NULL ";
		}
		if(plot.getEmbadon()!=null){
			embadon = " AND EMBADON="+plot.getEmbadon().getDoubleFormat();
		}else{
			embadon = " AND EMBADON IS NULL ";
		}
		
		if(plot.getOtherFeatures().contains("'")){
			plot.setOtherFeatures(plot.getOtherFeatures().replace("'"," "));
		}
		if(plot.getSecArea()!=null && plot.getSecArea().contains("'")){
			plot.setSecArea(plot.getSecArea().replace("'"," "));
		}
		/************************************************************************/
		try {
			stmt = connection.createStatement();
		    String query = "SELECT COUNT(*) AS SUM FROM ann_search_info as S,ann_sell_earth as E WHERE S.SEARCHID = E.SEARCHID AND"
					+ " CATEGORY_ID="
					+ AnnKeywords.SELL_EARTH_CODE
					+ " AND ISOFFER="
					+ isOffer
					+ " AND SOURCE_ID=" 
					+ sourceId
					+ " AND MAINAREA_ID="
					+ plot.getMainAreaType().getId()
					+ " AND TYPE_ID=" 
					+ plot.getType().getId()
					+ secondArea
					+ inmap
					+ embadon
					+ price
					+ coo_id
			        + " AND OTHER='" 
				 	+ plot.getOtherFeatures()
				    +"'";
			rset = stmt.executeQuery(query);
			while (rset.next()) {
				sum=rset.getInt("SUM");
			}
		} catch (SQLException ex) {
			ex.printStackTrace();
		} finally {
			if (rset != null) {
				try {
					rset.close();
				} catch (SQLException ex) {
					ex.printStackTrace();
					System.out.println("\nError in closing result set");
				}
			}
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException ex) {
					ex.printStackTrace();
					System.out.println("\nError in closing statement");
				}
			}
			if(sum!=0){
				return true;
			}
			return false;
		}
	}
	
	public static boolean isHouseAnnAlreadyIn(int isOffer, int sourceId, int categoryId,HouseAnnouncement house,Connection connection) {
		Statement stmt = null;
		ResultSet rset = null;
		Integer sum =0;
		String query="";
		/*******************in case some are null**********************************/
		String secondArea="";
		String price=null;
		String coo_id=null;
		String embadon = null;
		String bedrooms="";
		if(house.getSecArea()!=null){
			secondArea=" AND SECONDAREA='"+house.getSecArea()+"'";
		}else{
			secondArea=" AND SECONDAREA IS NULL ";
		}
		if(house.getPrice()!=null){
			price = " AND PRICE="+house.getPrice();
		}else{
			price = " AND PRICE IS NULL ";
		}
		if(house.getCoo_id()!=null){
			coo_id = " AND COO_ID="+house.getCoo_id();
		}else{
			coo_id = " AND COO_ID IS NULL ";
		}
		if(house.getRoomNumber()!=null){
			coo_id = " AND BEDROOMS='"+house.getRoomNumber()+"'";
		}else{
			coo_id = " AND BEDROOMS IS NULL ";
		}
		if(house.getEmbadon()!=null){
			embadon = " AND EMBADON="+house.getEmbadon().getDoubleFormat();
		}else{
			embadon = " AND EMBADON IS NULL ";
		}
		if(house.getOtherFeatures().contains("'")){
			house.setOtherFeatures(house.getOtherFeatures().replace("'"," "));
		}
		if(house.getSecArea()!=null && house.getSecArea().contains("'")){
			house.setSecArea(house.getSecArea().replace("'"," "));
		}
		/************************************************************************/
		try {
			stmt = connection.createStatement();
		    query = "SELECT COUNT(*) AS SUM FROM ann_search_info as S,ann_house as E WHERE S.SEARCHID = E.SEARCHID AND"
					+ " CATEGORY_ID="
					+ categoryId
					+ " AND ISOFFER="
					+ isOffer
					+ " AND SOURCE_ID=" 
					+ sourceId
					+ " AND MAINAREA_ID="
					+ house.getMainArea().getId()
					+ " AND TYPE_ID=" 
					+ house.getType().getId()
					//+ secondArea
					//+ bedrooms
					//+ embadon
					//+ price
					//+ coo_id
					+ " AND OTHER='" 
					+ house.getOtherFeatures()
					+"'";
			rset = stmt.executeQuery(query);
			while (rset.next()) {
				sum=rset.getInt("SUM");
			}
		} catch (SQLException ex) {
			System.out.println("QUERY:"+query);
			ex.printStackTrace();
		} finally {
			if (rset != null) {
				try {
					rset.close();
				} catch (SQLException ex) {
					ex.printStackTrace();
					System.out.println("\nError in closing result set");
				}
			}
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException ex) {
					ex.printStackTrace();
					System.out.println("\nError in closing statement");
				}
			}
			if(sum!=0){
				return true;
			}
			return false;
		}
	}
	

	@SuppressWarnings("finally")
	public static boolean isAuctionAnnAlreadyIn(
			int isOffer, int sourceId,Auction auction,Connection connection) {
		Statement stmt = null;
		ResultSet rset = null;
		Integer sum = 0;
		/*******************in case some are null**********************************/
		String secondArea="";
		String price=null;
		String percentage=null;
		if(auction.getSecArea()!=null){
			secondArea=" AND SECONDAREA='"+auction.getSecArea()+"'";
		}else{
			secondArea=" AND SECONDAREA IS NULL ";
		}
		if(auction.getPrice()!=null){
			price = " AND PRICE="+auction.getPrice();
		}else{
			price = " AND PRICE IS NULL ";
		}
		if(auction.getPercentage()!=null){
			percentage = " AND PERCENTAGE="+auction.getPercentage();
		}else{
			percentage = " AND PERCENTAGE IS NULL ";
		}
		/************************************************************************/
		try {
			stmt = connection.createStatement();
			String query = "SELECT COUNT(*) AS SUM FROM ann_search_info as S,ann_auction as E WHERE S.SEARCHID = E.SEARCHID AND"
					+ " CATEGORY_ID="
					+ AnnKeywords.AUCTION_CODE
					+ " AND ISOFFER="
					+ isOffer
					+ " AND SOURCE_ID=" 
					+ sourceId
					+ " AND MAINAREA_ID="
					+ auction.getMainAreaType().getId()
					+ " AND TYPE_ID=" 
					+ auction.getType().getId()
					+ secondArea
					+ percentage
					+ price
					+ " AND OTHER='" 
					+ auction.getOtherFeatures()
					+"'";
			rset = stmt.executeQuery(query);
			while (rset.next()) {
				sum=rset.getInt("SUM");
			}
		} catch (SQLException ex) {
			ex.printStackTrace();
		} finally {
			if (rset != null) {
				try {
					rset.close();
				} catch (SQLException ex) {
					ex.printStackTrace();
					System.out.println("\nError in closing result set");
				}
			}
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException ex) {
					ex.printStackTrace();
					System.out.println("\nError in closing statement");
				}
			}
			if(sum!=0){
				return true;
			}
			return false;
		}
	}
	
}
