package crawling.databasecleaner;

import java.sql.Connection;
import java.sql.Date;
import java.sql.DriverManager;
import java.util.ArrayList;
import java.util.Properties;

import crawling.AnnKeywords;
import crawling.database.DatabaseDeleteManager;
import crawling.database.DatabaseSelectManager;
import crawling.entities.HouseAnnouncement;
import crawling.entities.IdDescription;
import crawling.entities.PlotSellingAnnouncement;

public class WrongRecordsCleaner {
	
	private int categoryId;

	private int sourceId;

	private int nomosId;

	private int isOffer;
	
	private Date fromDate;
	
	private static Connection connection;

	public WrongRecordsCleaner(int categoryId, int sourceId, int nomosId, int isOffer, Date fromDate) {
		this.categoryId = categoryId;
		this.sourceId = sourceId;
		this.nomosId = nomosId;
		this.isOffer = isOffer;
		this.fromDate = fromDate;
		cleanDublicateEntries();
	}
	private static boolean openMySQLConnection() {
		try {
			Class.forName("com.mysql.jdbc.Driver");
			Properties props = new Properties();
			props.put("user", "root");
			props.put("password", "");
			props.put("useUnicode", "true");
			props.put("characterEncoding", "utf-8");
			/*connection = DriverManager.getConnection(
					"jdbc:mysql://localhost:3306/temp09062008", props);*/
			connection = DriverManager.getConnection(
					"jdbc:mysql://localhost/temp18042008", props);
			/*connection = DriverManager.getConnection(
					"jdbc:mysql://localhost/temp09062009", props);*/
			return true;
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println("ERROR: Failed to get connection to database!");
			return false;
		}
	}

	private void cleanDublicateEntries() {
		if (categoryId == AnnKeywords.SELL_EARTH_CODE) {
			cleanSellEarthTable();
		} else if (categoryId == AnnKeywords.SELL_HOUSE_CODE
				|| categoryId == AnnKeywords.RENT_HOUSE_CODE) {
			cleanHouseTable();
		} 
	}
	
	private void cleanSellEarthTable(){
		ArrayList<PlotSellingAnnouncement> anns = DatabaseSelectManager.getEarthAnnouncement(isOffer,sourceId,nomosId,fromDate,connection);
		ArrayList<Integer> idsToDelete= new ArrayList<Integer>(0);
		for(PlotSellingAnnouncement ann:anns){
			idsToDelete.add(ann.getId());
		}

		DatabaseDeleteManager.deleteAnnSellEarthRecords(idsToDelete,connection);
		DatabaseDeleteManager.deletePeriodsRecords(idsToDelete,AnnKeywords.SELL_EARTH_CODE,connection);
		DatabaseDeleteManager.deletePhonesRecords(idsToDelete,AnnKeywords.SELL_EARTH_CODE,connection);
	}
	
	private void cleanHouseTable(){
		ArrayList<HouseAnnouncement> anns = DatabaseSelectManager.getHouseAnnouncement(isOffer,categoryId,sourceId,nomosId,fromDate,connection);
		ArrayList<Integer> idsToDelete= new ArrayList<Integer>(0);
		for(HouseAnnouncement ann:anns){
			idsToDelete.add(ann.getId());
		}
		DatabaseDeleteManager.deleteAnnHousesRecords(idsToDelete,
				connection);
		DatabaseDeleteManager.deletePeriodsRecords(idsToDelete,
				categoryId, connection);
		DatabaseDeleteManager.deletePhonesRecords(idsToDelete,
				categoryId, connection);
		DatabaseDeleteManager.deleteOrofosRecords(idsToDelete,connection);
	}
	
	public static void main(String[] args) {
		openMySQLConnection();
		ArrayList<IdDescription> diamerismata = DatabaseSelectManager
				.getDiamerismata(connection);
		for (IdDescription diam : diamerismata) {
			ArrayList<IdDescription> nomoi = DatabaseSelectManager
					.getNomoysOfDiamerismata(diam.getId(), connection);
			for (IdDescription nomos : nomoi) {
				System.out.println("NOMOS:"+nomos.getDescription());
//				WrongRecordsCleaner earthCleaner = new WrongRecordsCleaner(
//						AnnKeywords.SELL_EARTH_CODE,
//						AnnKeywords.XRYSH_EYKAIRIA, nomos.getId(), 0);
		WrongRecordsCleaner rentHouseCleaner = new WrongRecordsCleaner(AnnKeywords.RENT_HOUSE_CODE,
						AnnKeywords.XRYSH_EYKAIRIA,nomos.getId(),0,Date.valueOf("2010-05-21"));
//				WrongRecordsCleaner sellHouseCleaner = new WrongRecordsCleaner(AnnKeywords.SELL_HOUSE_CODE,
//						AnnKeywords.XRYSH_EYKAIRIA,nomos.getId(),0);
			}
		}
	}
}
