package crawling.entities;

import java.util.ArrayList;

public class Announcement {
	
	//announcement Id
	private int anId;
	private int anType;
	//search Id 
	private int searchId;
	//text of announcement
	private String description;
	//periods of the different appearences of the announcement
	private ArrayList<Period> periods;
	
	/**
	 * Creates an announcement
	 */
	public Announcement(){
		periods = new ArrayList<Period>(0);
	}
	
	
	
	public Announcement(ArrayList<Period> periods) {
		this.periods = periods;
	}


	/**
	 * Creates an announcement
	 * @param anId
	 * @param searchId
	 * @param description
	 */
	public Announcement(int anId, int searchId,String description,int anType) {
		this.anId = anId;
		this.searchId = searchId;
		this.description = description;
		periods = new ArrayList<Period>(0);
		this.anType = anType;
	}
	
	public Announcement(String description) {
		this.description = description;
		periods = new ArrayList<Period>(0);
	}
	
	public int getAnId() {
		return anId;
	}
	public void setAnId(int anId) {
		this.anId = anId;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}

	public int getSearchId() {
		return searchId;
	}
	public void setSearchId(int searchId) {
		this.searchId = searchId;
	}

	public ArrayList<Period> getPeriods() {
		return periods;
	}
	public void setPeriods(ArrayList<Period> periods) {
		this.periods = periods;
	}
	public int getAnType() {
		return anType;
	}
	public void setAnType(int anType) {
		this.anType = anType;
	}

	
}
