/**
 * class HouseAnnouncement
 * @author Dimitra Xidara
 */
package crawling.entities;

import java.util.ArrayList;

import crawling.Utilities;

public class HouseAnnouncement{

	private int id;
	private int searchId;
	private IdDescription mainAreaType;
	private String secArea;
	private ArrayList<Integer> orofoi;
	private String roomNumber;
	private DoubleStringFormat embadon;
	private Double price;
	private String otherFeatures;
	private IdDescription type;
	private boolean rent = true;
	private ArrayList<String> phones;
	private Integer coo_id;


	public HouseAnnouncement() {
		phones = new ArrayList<String>(0);
	}

	
	public HouseAnnouncement(int id) {
		this.id = id;
	}


	public HouseAnnouncement(int id, IdDescription mainAreaType, String secArea, String roomNumber, DoubleStringFormat embadon, Double price, String otherFeatures, IdDescription type, boolean rent,ArrayList<Integer> orofoi,ArrayList<String> phones,int searchId) {
		this.id = id;
		this.mainAreaType = mainAreaType;
		this.secArea = secArea;
		this.roomNumber = roomNumber;
		this.embadon = embadon;
		this.price = price;
		this.otherFeatures = otherFeatures;
		this.type = type;
		this.rent = rent;
		this.orofoi = orofoi;
		this.phones =  phones;
		this.searchId = searchId;
	}


	public HouseAnnouncement(IdDescription mainArea, String secArea, IdDescription type, ArrayList<Integer> orofoi, String roomNumber, DoubleStringFormat embadon, Double price, String otherFeatures, boolean rent) {
		this.secArea = secArea;
		this.type = type;
		this.orofoi = orofoi;
		this.roomNumber = roomNumber;
		this.embadon = embadon;
		this.price = price;
		this.otherFeatures = otherFeatures;
		this.rent = rent;
		mainArea = new IdDescription();
	}
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public DoubleStringFormat getEmbadon() {
		return embadon;
	}

	public void setEmbadon(DoubleStringFormat embadon) {
		this.embadon = embadon;
	}

	public IdDescription getMainArea() {
		return mainAreaType;
	}

	public void setMainArea(IdDescription mainArea) {
		this.mainAreaType = mainArea;
	}

	public ArrayList<Integer> getOrofoi() {
		return orofoi;
	}

	public void setOrofoi(ArrayList<Integer> orofoi) {
		this.orofoi = orofoi;
	}

	public Double getPrice() {
		return price;
	}

	public void setPrice(Double price) {
		this.price = price;
	}

	public String getRoomNumber() {
		return roomNumber;
	}

	public void setRoomNumber(String roomNumber) {
		this.roomNumber = roomNumber;
	}

	public String getSecArea() {
		return secArea;
	}

	public void setSecArea(String secArea) {
		this.secArea = secArea;
	}

	public IdDescription getType() {
		return type;
	}

	public void setType(IdDescription type) {
		this.type = type;
	}

	public String getOtherFeatures() {
		return otherFeatures;
	}

	public void setOtherFeatures(String otherFeatures) {
		this.otherFeatures = otherFeatures;
	}

	public boolean isRent() {
		return rent;
	}

	public void setRent(boolean rent) {
		this.rent = rent;
	}
	
	public ArrayList<String> getPhones() {
		return phones;
	}


	public void setPhones(ArrayList<String> phones) {
		this.phones = phones;
	}

	public Integer getCoo_id() {
		return coo_id;
	}

	public void setCoo_id(Integer coo_id) {
		this.coo_id = coo_id;
	}
	@Override
	public String toString() {
		String orofos = "";
		if(orofoi!=null){
		for(Integer orf : orofoi){
			orofos+=orf+" ";
		}
		}
		String phonesString="";
		for(String phone:phones){
			phonesString+=phone+" ";
		}
		return "MAINAREA:"+mainAreaType+" SECONDAREA:"+secArea+" TYPE:"+type+" OROFOI:"+orofos+" PHONES:"+phonesString+
		"\nROOM NUMBER:"+roomNumber+" EMBADON:"+embadon+" PRICE:"+price+" OTHERFEATURES:"+otherFeatures+" RENT:"+rent;
	}
	
	public static boolean equal(HouseAnnouncement ann1,HouseAnnouncement ann2){
		if(
				Utilities.isEqualOtherFeatures(ann1.getOtherFeatures(),ann2.getOtherFeatures())&&
				IdDescription.equals(ann1.getMainArea(),ann2.getMainArea())&&
				Utilities.isEqual(ann1.getRoomNumber(),ann2.getRoomNumber())&&
				Utilities.isEqual(ann1.getSecArea(),ann2.getSecArea())&&
				IdDescription.equals(ann1.getType(),ann2.getType())&&
				DoubleStringFormat.equals(ann1.getEmbadon(),ann2.getEmbadon())&&
				Utilities.isEqual(ann1.getPrice(),ann2.getPrice())
//				Utilities.isEqual(ann1.getCoo_id(),ann2.getCoo_id())&&
//				(ann1.isRent()==ann2.isRent())
				){
			return true;
		}
		return false;
	}


	public int getSearchId() {
		return searchId;
	}


	public void setSearchId(int searchId) {
		this.searchId = searchId;
	}


	
	
}
