/**
 * class Period
 * @author Dimitra Xidara
 */
package crawling.entities;

import java.sql.Date;

public class Period {
	
	private int id;
	private Date start;
	private Date end;
	private Date dd;
	/**
	 *Constructs an unspecified period
	 */
	public Period() {
	}

	/**
	 * Constructs a specified period from the given start and end date
	 * @param start
	 * @param end
	 */
	public Period(Date start, Date end) {
		this.start = start;
		this.end = end;
	}

	/**
	 * Constructs a specified period from the given start and end date
	 * @param start
	 * @param end
	 */
	public Period(int id,Date start, Date end, Date dd) {
		this.id = id;
		this.start = start;
		this.end = end;
		this.dd = dd;
	}
	/**
	 * Constructs a specified period from the given start and end date
	 * @param start
	 * @param end
	 */
	public Period(int id,Date start, Date end) {
		this.id = id;
		this.start = start;
		this.end = end;
	}
	public Date getEnd() {
		return end;
	}

	public void setEnd(Date end) {
		this.end = end;
	}

	public Date getStart() {
		return start;
	}

	public void setStart(Date start) {
		this.start = start;
	}

	public Date getDd() {
		return dd;
	}

	public void setDd(Date dd) {
		this.dd = dd;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	@Override
	public String toString() {
		return "startDate:"+start+" endDate:"+end;
	}
	
	public static boolean equal(Period period1,Period period2){
		if(period1==null && period2==null){
			return true;
		}else if((period1!=null && period2==null)||(period1==null && period2!=null)){
			return false;
		}else{
			if(period1.getStart().equals(period2.getStart()) && period2.getEnd().equals(period2.getEnd())){
				return true;
			}
			return false;
		}
	}


}
