/**
 * class PlotSellingAnnouncement
 * @author Dimitra Xidara
 */
package crawling.entities;

import java.util.ArrayList;

import crawling.Utilities;

public class PlotSellingAnnouncement {

	private int id;
	
	private int searchId;

	private IdDescription mainAreaType;

	private String secArea;

	private IdDescription type;

	private String inMap;

	private DoubleStringFormat embadon;

	private Double price;

	private String otherFeatures;
	
	private ArrayList<String> phones;
	


	public PlotSellingAnnouncement(int id) {
		this.id = id;
	}

	public PlotSellingAnnouncement(IdDescription mainAreaType, String secArea,
			IdDescription type, String inMap, DoubleStringFormat embadon,
			Double price, String otherFeatures, ArrayList<String> phones,
			int searchId) {
		this.mainAreaType = mainAreaType;
		this.secArea = secArea;
		this.type = type;
		this.inMap = inMap;
		this.embadon = embadon;
		this.price = price;
		this.otherFeatures = otherFeatures;
		this.phones =  phones;
		this.searchId = searchId;
	}

	public PlotSellingAnnouncement(int id, IdDescription mainAreaType,
			String secArea, IdDescription type, String inMap,
			DoubleStringFormat embadon, Double price, String otherFeatures,ArrayList<String> phones,
			int searchId) {
		this.id = id;
		this.mainAreaType = mainAreaType;
		this.secArea = secArea;
		this.type = type;
		this.inMap = inMap;
		this.embadon = embadon;
		this.price = price;
		this.otherFeatures = otherFeatures;
		this.phones = phones;
		this.searchId = searchId;
	}

	
	
	public PlotSellingAnnouncement(int id, String secArea, DoubleStringFormat embadon, Double price, String otherFeatures) {
		this.id = id;
		this.secArea = secArea;
		this.embadon = embadon;
		this.price = price;
		this.otherFeatures = otherFeatures;
	}

	public DoubleStringFormat getEmbadon() {
		return embadon;
	}

	public void setEmbadon(DoubleStringFormat embadon) {
		this.embadon = embadon;
	}

	public String getInMap() {
		return inMap;
	}

	public void setInMap(String inMap) {
		this.inMap = inMap;
	}

	public IdDescription getMainAreaType() {
		return mainAreaType;
	}

	public void setMainAreaType(IdDescription mainAreaType) {
		this.mainAreaType = mainAreaType;
	}

	public Double getPrice() {
		return price;
	}

	public void setPrice(Double price) {
		this.price = price;
	}

	public String getSecArea() {
		return secArea;
	}

	public void setSecArea(String secArea) {
		this.secArea = secArea;
	}

	public IdDescription getType() {
		return type;
	}

	public void setType(IdDescription type) {
		this.type = type;
	}

	public String getOtherFeatures() {
		return otherFeatures;
	}

	public void setOtherFeatures(String otherFeatures) {
		this.otherFeatures = otherFeatures;
	}

	public ArrayList<String> getPhones() {
		return phones;
	}

	public void setPhones(ArrayList<String> phones) {
		this.phones = phones;
	}

	public int getSearchId() {
		return searchId;
	}

	public void setSearchId(int searchId) {
		this.searchId = searchId;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	@Override
	public String toString() {
		String typeName = null;
		if (type != null) {
			typeName = type.getDescription();
		}String phonesString="";
		for(String phone:phones){
			phonesString+=phone+" ";
		}
		return "Main area:" + mainAreaType + " secondArea:" + secArea
				+ " type:" + typeName + " inMap:" + inMap + "\n embadon:"
				+ embadon + " price:" + price +" phones:"+phonesString +" otherFeatures:"
				+ otherFeatures;
	}
	//@TODO: DECIDE TO DO IT INT OR INTEGER
	private Integer coo_id;

	public Integer getCoo_id() {
		return coo_id;
	}

	public void setCoo_id(Integer coo_id) {
		this.coo_id = coo_id;
	}

	public PlotSellingAnnouncement() {
		phones =  new ArrayList<String>(0);
	}
	public static boolean equal(PlotSellingAnnouncement ann1,PlotSellingAnnouncement ann2){
		if(Utilities.isEqualOtherFeatures(ann1.getOtherFeatures(),ann2.getOtherFeatures())&&
				Utilities.isEqual(ann1.getInMap(),ann2.getInMap())&&
				Utilities.isEqual(ann1.getSecArea(),ann2.getSecArea())&&
				IdDescription.equals(ann1.getMainAreaType(),ann2.getMainAreaType())&&
				IdDescription.equals(ann1.getType(),ann2.getType())&&
				DoubleStringFormat.equals(ann1.getEmbadon(),ann2.getEmbadon())&&
				Utilities.isEqual(ann1.getPrice(),ann2.getPrice())&&
				Utilities.isEqual(ann1.getCoo_id(),ann2.getCoo_id())){
			return true;
		}
		return false;
	}


}
