/**
 * class SearchInfo
 * @author Dimitra Xidara
 */
package crawling.entities;

import java.sql.Date;

public class SearchInfo {
	
	private int searchId;
	private java.sql.Date date;
	private IdDescription category;
	private IdDescription diamerisma;
	private IdDescription nomos;
	private IdDescription perioxh;
	private int pages;
	private int sourceId;
	private int isOffer;
	private boolean isSold;
	
	/**
	 * Constructs a search Info object
	 */
	public SearchInfo() {
	}
	
	public SearchInfo(Date date, IdDescription category, IdDescription nomos, int sourceId, int isOffer, boolean isSold) {
		this.date = date;
		this.category = category;
		this.nomos = nomos;
		this.sourceId = sourceId;
		this.isOffer = isOffer;
		this.isSold = isSold;
	}

	/**
	 * Constructs a search Info object
	 * @param date
	 * @param category
	 * @param diamerisma
	 * @param nomos
	 * @param pages
	 * @param results
	 */
	public SearchInfo(Date date, IdDescription category, IdDescription diamerisma, IdDescription nomos, IdDescription perioxh,int sourceId, int isOffer, boolean isSold) {
		this.date = date;
		this.category = category;
		this.diamerisma = diamerisma;
		this.nomos = nomos;
		this.perioxh = perioxh;
		this.sourceId = sourceId;
		this.isOffer = isOffer;
		this.isSold = isSold;
	}

	public IdDescription getCategory() {
		return category;
	}

	public void setCategory(IdDescription category) {
		this.category = category;
	}

	public java.sql.Date getDate() {
		return date;
	}

	public void setDate(java.sql.Date date) {
		this.date = date;
	}

	public IdDescription getDiamerisma() {
		return diamerisma;
	}

	public void setDiamerisma(IdDescription diamerisma) {
		this.diamerisma = diamerisma;
	}

	public IdDescription getNomos() {
		return nomos;
	}

	public void setNomos(IdDescription nomos) {
		this.nomos = nomos;
	}

	public int getSearchId() {
		return searchId;
	}

	public void setSearchId(int searchId) {
		this.searchId = searchId;
	}

	public IdDescription getPerioxh() {
		return perioxh;
	}

	public void setPerioxh(IdDescription perioxh) {
		this.perioxh = perioxh;
	}

	public int getSourceId() {
		return sourceId;
	}

	public void setSourceId(int sourceId) {
		this.sourceId = sourceId;
	}

	public int isOffer() {
		return isOffer;
	}

	public void setOffer(int isOffer) {
		this.isOffer = isOffer;
	}

	public int getPages(){
		return pages;
	}
	
	public void setPages(int pages){
		this.pages = pages;
	}

	public boolean isSold() {
		return isSold;
	}

	public void setSold(boolean isSold) {
		this.isSold = isSold;
	}
}
