/****************************************
 * 			Syrgiannis Sotirios         *  
 ****************************************/
package crawling.kathimerini;

import java.sql.Connection;
import java.sql.DriverManager;
import java.util.ArrayList;
import java.util.Properties;

import crawling.AnnKeywords;
import crawling.ReadSource;
import crawling.Utilities;
import crawling.WordUtilities;
import crawling.database.DatabaseSelectManager;
import crawling.database.DatabaseUpdateManager;
import crawling.entities.Announcement;
import crawling.entities.HouseAnnouncement;
import crawling.entities.IdDescription;
import crawling.entities.PlotSellingAnnouncement;
import crawling.entities.SearchInfo;


public class KathimeriniAdv {
//*******************************************************************************************************************		
// URLS Gia thn eksagwgh twn aggeliwn
//*******************************************************************************************************************		
	public static final String MAIN_URL = "http://trans.kathimerini.gr";

	//public static final String SELL_HOUSE_URL = "http://trans.kathimerini.gr/4dcgi/classif/categorie_1flag2?cat?_id%3D02";

	public static final String AKINHTA_AN_ATTIKHS = "/4dcgi/classif/subcategorie_flag5frame12574?cat?_id=031";

	public static final String AKINHTA_BOR_ATTIKHS = "/4dcgi/classif/subcategorie_flag5frame18416?cat?_id=025";
	
	public static final String AKINHTA_DYT_ATTIKHS="/4dcgi/classif/subcategorie_flag5frame31635?cat?_id=033";
	
	public static final String AKINHTA_NOTIAS_ATHINAS = "/4dcgi/classif/subcategorie_flag5frame4616?cat?_id=026";

	public static final String AKINHTA_DHMOY_ATHINAS = "/4dcgi/classif/subcategorie_flag5frame26760?cat?_id=027";

	public static final String AKINHTA_DHMOY_PEIRAIA = "/4dcgi/classif/subcategorie_flag5frame17046?cat?_id=030";

	public static final String AKINHTA_NOMOY_ATTIKHS = "/4dcgi/classif/subcategorie_flag5frame6303?cat?_id=029";

	public static final String AKINHTA_SE_OLH_TH_XWRA = "/4dcgi/classif/subcategorie_flag5frame26031?cat?_id=032";

	public static final String AKINHTA_THESSALONIKHS = "/4dcgi/classif/subcategorie_flag8frame9588?cat?_id=046";

	//public static final String SELL_EARTH_URL = "http://trans.kathimerini.gr/4dcgi/classif/categorie_1flag2?cat?_id%3D04";

	public static final String OIKOPEDA_AN_ATTIKHS = "/4dcgi/classif/subcategorie_flag4frame15035?cat?_id=018";

	public static final String OIKOPEDA_BOR_ATTIKHS = "/4dcgi/classif/subcategorie_flag4frame20941?cat?_id=017";

	public static final String OIKOPEDA_DYTIKHS_ATTIKHS = "/4dcgi/classif/subcategorie_flag4frame3054?cat?_id=023";

	public static final String OIKOPEDA_DHMOY_ATHINAS = "/4dcgi/classif/subcategorie_flag4frame24603?cat?_id=021";

	public static final String OIKOPEDA_DHMOY_PEIRAIA = "/4dcgi/classif/subcategorie_flag4frame4158?cat?_id=019";

	public static final String OIKOPEDA_NOTIAS_ATHINAS = "/4dcgi/classif/subcategorie_flag4frame26930?cat?_id=016";

	public static final String OIKOPEDA_NOMOY_ATTIKHS = "/4dcgi/classif/subcategorie_flag4frame23317?cat?_id=022";

	public static final String OIKOPEDA_SE_OLH_TH_XWRA = "/4dcgi/classif/subcategorie_flag4frame21004?cat?_id=020";

	public static final String OIKOPEDA_THESSALONIKHS = "/4dcgi/classif/subcategorie_flag8frame19000?cat?_id=050";

	public static final String RENT_URL = "/4dcgi/classif/subcategorie_flag2frame2375?cat?_id=06";
	public static final String THESSALONIKH_RENT_URL = "/4dcgi/classif/subcategorie_flag8frame32334?cat?_id=049";
//********************************************************************************************************************
	
//********************************************************************************************************************
// Extraction Tags
//********************************************************************************************************************
	public static final String LINK_START_TAG = "<td class=small><a href=";

	public static final String LINK_END_TAG = "</a>";

	public static final String ADVS_START_TAG = "<TR><TD><span class=\"sidemenulinks\"><P>";
												 //<TR><TD><span class="sidemenulinks">	
	public static final String ADVS_END_TAG = "</span>";

	public static final String DEVIDE_TAG = "<HR>";
    int counter=0;
	private Connection connection;
//**********************************************************************************************************************		

//**********************************************************************************************************************
//Constructors Of KathimeriniAdv()
//**********************************************************************************************************************		
	public KathimeriniAdv()
{     this(-1);
		System.out.println("\t \t \t **************************************************");
		System.out.println(" \t\t\t *\t\tStarting Kathimerini                   *");
		System.out.println("\t \t \t **************************************************");
		System.out.println("\n");

}
//**********************************************************************************************************************			
public KathimeriniAdv(int typeOfAdv) {
//*****************************************************************************************************************
//Periptwsh Eksagwghs Aggeliwn Pou Aforoun THN Pwlhsh Katoikiwn
//*****************************************************************************************************************
	System.out.println("\t \t \t **************************************************");
	System.out.println(" \t\t\t *\t\tStarting Kathimerini                   *");
	System.out.println("\t \t \t **************************************************");
	System.out.println("\n");
	String url;
	if (typeOfAdv == AnnKeywords.SELL_HOUSE_CODE) {
		System.out.println("\t \t \t **************************************************");
		System.out.println(" \t \t \t *\t\tSELL HOUSE                   *");
		System.out.println("\t \t \t **************************************************");
		advExtraction(MAIN_URL + AKINHTA_AN_ATTIKHS, false,
				AnnKeywords.SELL_HOUSE_CODE);
		url = MAIN_URL + AKINHTA_AN_ATTIKHS;
		System.out.println("URL: "+ url);
		advExtraction(MAIN_URL + AKINHTA_NOTIAS_ATHINAS,false,
				AnnKeywords.SELL_HOUSE_CODE);
		url = MAIN_URL + AKINHTA_NOTIAS_ATHINAS;
		System.out.println("URL: "+ url);
		advExtraction(MAIN_URL + AKINHTA_BOR_ATTIKHS ,false,
				AnnKeywords.SELL_HOUSE_CODE);
		url = MAIN_URL + AKINHTA_BOR_ATTIKHS;
		System.out.println("URL: "+ url);
		advExtraction(MAIN_URL + AKINHTA_DYT_ATTIKHS , false,
				AnnKeywords.SELL_HOUSE_CODE);
		url = MAIN_URL + AKINHTA_DYT_ATTIKHS;
		System.out.println("URL: "+ url);
		advExtraction(MAIN_URL + AKINHTA_DHMOY_ATHINAS, false,
				AnnKeywords.SELL_HOUSE_CODE);
		url = MAIN_URL + AKINHTA_DHMOY_ATHINAS;
		System.out.println("URL: "+ url);
		advExtraction(MAIN_URL + AKINHTA_DHMOY_PEIRAIA, false,
				AnnKeywords.SELL_HOUSE_CODE);
		url = MAIN_URL + AKINHTA_DHMOY_PEIRAIA;
		System.out.println("URL: "+ url);
		advExtraction(MAIN_URL + AKINHTA_NOMOY_ATTIKHS, false,
				AnnKeywords.SELL_HOUSE_CODE);
		url = MAIN_URL + AKINHTA_NOMOY_ATTIKHS;
		System.out.println("URL: "+ url);
	    advExtraction(MAIN_URL + AKINHTA_SE_OLH_TH_XWRA, false,
			AnnKeywords.SELL_HOUSE_CODE);
	    url = MAIN_URL + AKINHTA_SE_OLH_TH_XWRA;
		System.out.println("URL: "+ url);
		advExtraction(MAIN_URL + AKINHTA_THESSALONIKHS, false,
			AnnKeywords.SELL_HOUSE_CODE);
		url = MAIN_URL + AKINHTA_THESSALONIKHS;
		System.out.println("URL: "+ url);
		System.out.println("Finished Kathimerini : Sell Houses");
}//domh IF
//****************************************************************************************************************
	
//****************************************************************************************************************
//Periptwsh Eksagwghs Aggeliwn Pou Aforoun THN Pwlhsh Oikopedwn
//****************************************************************************************************************
	else if (typeOfAdv == AnnKeywords.SELL_EARTH_CODE) {
		System.out.println("\t \t \t **************************************************");
		System.out.println(" \t \t \t *   SELL EARTH    *");
		System.out.println("\t \t \t **************************************************");
		advExtraction(MAIN_URL + OIKOPEDA_AN_ATTIKHS, false,
				AnnKeywords.SELL_EARTH_CODE);
		url = MAIN_URL + OIKOPEDA_AN_ATTIKHS;
		System.out.println("URL: "+ url);
		advExtraction(MAIN_URL + OIKOPEDA_DYTIKHS_ATTIKHS , false,
				AnnKeywords.SELL_EARTH_CODE);
		url = MAIN_URL + OIKOPEDA_DYTIKHS_ATTIKHS;
		System.out.println("URL: "+ url);
		advExtraction(MAIN_URL + OIKOPEDA_BOR_ATTIKHS, false,
				AnnKeywords.SELL_EARTH_CODE);
		url = MAIN_URL + OIKOPEDA_BOR_ATTIKHS;
		System.out.println("URL: "+ url);
		advExtraction(MAIN_URL + OIKOPEDA_THESSALONIKHS, false,
				AnnKeywords.SELL_EARTH_CODE);
		url = MAIN_URL + OIKOPEDA_THESSALONIKHS;
		System.out.println("URL: "+ url);
		advExtraction(MAIN_URL + OIKOPEDA_DHMOY_ATHINAS, false,
				AnnKeywords.SELL_EARTH_CODE);
		url = MAIN_URL + OIKOPEDA_DHMOY_ATHINAS;
		System.out.println("URL: "+ url);
		advExtraction(MAIN_URL + OIKOPEDA_DHMOY_PEIRAIA, false,
				AnnKeywords.SELL_EARTH_CODE);
		url = MAIN_URL + OIKOPEDA_DHMOY_PEIRAIA;
		System.out.println("URL: "+ url);
		advExtraction(MAIN_URL + OIKOPEDA_DYTIKHS_ATTIKHS, false,
				AnnKeywords.SELL_EARTH_CODE);
		url = MAIN_URL + OIKOPEDA_DYTIKHS_ATTIKHS;
		System.out.println("URL: "+ url);
		advExtraction(MAIN_URL + OIKOPEDA_NOMOY_ATTIKHS, false,
				AnnKeywords.SELL_EARTH_CODE);
		url = MAIN_URL + OIKOPEDA_NOMOY_ATTIKHS;
		System.out.println("URL: "+ url);
		advExtraction(MAIN_URL + OIKOPEDA_NOTIAS_ATHINAS, false,
				AnnKeywords.SELL_EARTH_CODE);
		url = MAIN_URL + OIKOPEDA_NOTIAS_ATHINAS;
		System.out.println("URL: "+ url);
		System.out.println("Finished Kathimerini : Sell Earth");
	
//*****************************************************************************************************************
		
//*****************************************************************************************************************
//Periptwsh Eksagwghs Aggeliwn Pou Aforoun THN Enoikiash Katoikiwn
//*****************************************************************************************************************
	}//else if
	else if (typeOfAdv == AnnKeywords.RENT_HOUSE_CODE) {
		System.out.println("\t \t \t **************************************************");
		System.out.println(" \t \t \t * RENT HOUSE   *");
		System.out.println("\t \t \t **************************************************");
		advExtraction(MAIN_URL+RENT_URL, true, AnnKeywords.RENT_HOUSE_CODE);
		url = MAIN_URL + RENT_URL;
		System.out.println("URL: "+ url);
		advExtraction(MAIN_URL+THESSALONIKH_RENT_URL, true, AnnKeywords.RENT_HOUSE_CODE);
		url = MAIN_URL + THESSALONIKH_RENT_URL;
		System.out.println("URL: "+ url);
		
		System.out.println("Finished Kathimerini : Rent Houses");
		}
//*****************************************************************************************************************
	
//*****************************************************************************************************************
//Periptwsh opou den dinetai Orisma sto Antikeimeno Ths Klashs KathimeriniAdv
//Eksagwgh Kathe Eidous Aggelias (Pwlhshs,Enoikiashs Spitiwn Kai Pwlhshs Oikopedwn)
//*****************************************************************************************************************
	else{ 
			System.out.println("ÊáèçìåñéíÞ : Sell Houses ");
			
			advExtraction(MAIN_URL + AKINHTA_AN_ATTIKHS, false,
					AnnKeywords.SELL_HOUSE_CODE);
			advExtraction(MAIN_URL + AKINHTA_NOTIAS_ATHINAS,false,
					AnnKeywords.SELL_HOUSE_CODE);
			advExtraction(MAIN_URL + AKINHTA_BOR_ATTIKHS ,false,
					AnnKeywords.SELL_HOUSE_CODE);
			advExtraction(MAIN_URL + AKINHTA_DYT_ATTIKHS , false,
					AnnKeywords.SELL_HOUSE_CODE);
			advExtraction(MAIN_URL + AKINHTA_DHMOY_ATHINAS, false,
					AnnKeywords.SELL_HOUSE_CODE);
		    advExtraction(MAIN_URL + AKINHTA_DHMOY_PEIRAIA, false,
					AnnKeywords.SELL_HOUSE_CODE);
		    advExtraction(MAIN_URL + AKINHTA_NOMOY_ATTIKHS, false,
					AnnKeywords.SELL_HOUSE_CODE);
		    advExtraction(MAIN_URL + AKINHTA_SE_OLH_TH_XWRA, false,
	                AnnKeywords.SELL_HOUSE_CODE);
			advExtraction(MAIN_URL + AKINHTA_THESSALONIKHS, false,
				    AnnKeywords.SELL_HOUSE_CODE);
			System.out.println("Finished Kathimerini : Sell Houses");
			
		    System.out.println("ÊáèçìåñéíÞ : Sell Earth ");
			advExtraction(MAIN_URL + OIKOPEDA_AN_ATTIKHS, false,
					AnnKeywords.SELL_EARTH_CODE);
			advExtraction(MAIN_URL + OIKOPEDA_DYTIKHS_ATTIKHS , false,
					AnnKeywords.SELL_EARTH_CODE);
			advExtraction(MAIN_URL + OIKOPEDA_BOR_ATTIKHS, false,
					AnnKeywords.SELL_EARTH_CODE);
			advExtraction(MAIN_URL + OIKOPEDA_THESSALONIKHS, false,
					AnnKeywords.SELL_EARTH_CODE);
			advExtraction(MAIN_URL + OIKOPEDA_DHMOY_ATHINAS, false,
					AnnKeywords.SELL_EARTH_CODE);
			advExtraction(MAIN_URL + OIKOPEDA_DHMOY_PEIRAIA, false,
					AnnKeywords.SELL_EARTH_CODE);
			advExtraction(MAIN_URL + OIKOPEDA_DYTIKHS_ATTIKHS, false,
					AnnKeywords.SELL_EARTH_CODE);
			advExtraction(MAIN_URL + OIKOPEDA_NOMOY_ATTIKHS, false,
					AnnKeywords.SELL_EARTH_CODE);
			advExtraction(MAIN_URL + OIKOPEDA_NOTIAS_ATHINAS, false,
					AnnKeywords.SELL_EARTH_CODE);
			System.out.println("Finished Kathimerini : Sell Earth");
			
			System.out.println("ÊáèçìåñéíÞ : Rent Houses ");
			 advExtraction(MAIN_URL+RENT_URL, true, AnnKeywords.RENT_HOUSE_CODE);
			 advExtraction(MAIN_URL+THESSALONIKH_RENT_URL, true, AnnKeywords.RENT_HOUSE_CODE);
			 
			 System.out.println("Finished Kathimerini : Rent Houses");
		}
//***************************************************************************************************************
	
}//Public KathimeriniAdv(int typeofAdv)

//***************************************************************************************************************		

private void advExtraction(String URL, boolean isRent, int advType) {
	ReadSource rsrc = new ReadSource(URL, AnnKeywords.KATHIMERINI);
	//System.out.println("source\n"+rsrc);
	String source = rsrc.getSource();
	//System.out.println("source\n"+source);
	ArrayList<String> urls = Utilities.extractAllTexts(source,LINK_START_TAG, LINK_END_TAG);
	if (!openMySQLConnection()) {
		System.out.println("CAN'T MATCH AREA NAMES!ERROR IN OPENNING CONNECTION TO DATABASE!!!");
	}
	ArrayList<IdDescription> areaNames;
	int cont=0;
	for (String url : urls) {
//*****************************************************************************************************************
//Epeksergasia tou URL wste na eksagoume thn swsth apo auto plhroforia pou afora thn aggelia
//*****************************************************************************************************************	
		//System.out.println("Extracted text"+url);
		cont++;
		String temp = url.replace("\'", "");
		//System.out.println("Replaced text"+temp);
		String[] info = temp.split(">");
		//Split the string and save tha pattern before ">" into info[0] and tha pettern after ">" into info[1]
		//System.out.println("info"+ info[0]);
		//System.out.println("AREA:" + info[1]);
//*****************************************************************************************************************	
		IdDescription perioxh = null;
	int nomos=0;
		int id=1 ;
//******************************************************************************************************************
//Eksetazetai O nomos to opoio afora h sygkekrimenh aggelia kai ektelountai oi ekastote energeies analoga me 
//Ton nomo,perioxh,dimerisma ton opoio afora h sygkekrimenh aggelia		
//******************************************************************************************************************

//******************************************************************************************************************
//Elexnos gia to ean h Aggelia afora Akinhta kai Oikopeda THESSALONIKHS
//******************************************************************************************************************
		if (URL.equals(MAIN_URL + AKINHTA_THESSALONIKHS)|| URL.equals(MAIN_URL + OIKOPEDA_THESSALONIKHS)) {
			nomos=2;
			areaNames = DatabaseSelectManager.getPerioxesOfNomos(2,connection);
			//System.out.println(areaNames);
//*****************************************************************************************************************
//Klhsh Methodou fixPerioxes me orismata info[1]-perioxh,kai areanames
//Elenxos gia to ean h perioxh pou vrisketai sthn aggelia yparxei hdh sthn vash dedomenwn 
//Ean nai tote perioxh=null eisagetai sthn vash dedomenwn me to antistoixh Id tou Nomou pou antistoixei se auth
//diaforetika yparxei hdh sthn vash sto Table geo_perioxes kai den xreiazetai update to table.				
//*****************************************************************************************************************
		//System.out.println(areaNames);
			perioxh = fixPerioxes(info[1], areaNames);
			//System.out.println(perioxh);
			if (perioxh == null) {
				//id = DatabaseUpdateManager.updatePerioxesTable(info[1], nomos,connection);
				//System.out.println("NEW ID   ="+id);
				//System.out.println("UpdatePerioxesTable :"+info[1]);
				//perioxh = new IdDescription(id,info[1]);
			}
		}
//******************************************************************************************************************				
		
//******************************************************************************************************************
//Akinhta kai Oikopeda SE OLH THN XORA
//******************************************************************************************************************
		else if (URL.equals(MAIN_URL + AKINHTA_SE_OLH_TH_XWRA)|| URL.equals(MAIN_URL + OIKOPEDA_SE_OLH_TH_XWRA)) {
			ArrayList<IdDescription> diamerismata = DatabaseSelectManager.getDiamerismata(connection);
			for (IdDescription diamerisma : diamerismata) {
				ArrayList<IdDescription> nomoi = DatabaseSelectManager
						.getNomoysOfDiamerismata(diamerisma.getId(),connection);
				for (IdDescription nom : nomoi) {
					areaNames = DatabaseSelectManager.getPerioxesOfNomos(nom.getId(), connection);
					perioxh = fixPerioxes(info[1], areaNames);
					//SHMEIWSH PREPEI NA GINEI ELENXOS GIA TON EAN DEN YPARXEI H SYGKEKRIMENH PERIOXH 
					//STHN VASH DEDOMENON KAI NA EKTELESTEI UPDATE TOU TABLE WSTE NA EISAXTHEI H SYGKEKRIMENH
					//PERIOXH STHN VASH DEDOMENON
					if (perioxh != null) {
						nomos=nom.getId();
						break;
					}
				}
				if(perioxh!=null){
					break;
				}
			}
		}
//******************************************************************************************************************		
	
//***********************************************************************************************************************	
//Diaforetikh Periptwsh apo tis parapanw duo(Oikopeda kai Akinhta den vriskontai se THESSALONIKH KAI STHN YPOLOIPH XWRA).
//Sthn sugkerkimenhn periptwsh logw domhs tou Istotopou oi aggelies aforoun Oikopeda H Akinhta pou anhkoun thn ATTIKH
//***********************************************************************************************************************	
		else 
			{
			areaNames = DatabaseSelectManager.getPerioxesOfNomos(1,connection);
			nomos=1;
			perioxh = fixPerioxes(info[1], areaNames);
			//System.out.println("Methodos Fix_Perioxes");
			if (perioxh == null) {
				
				/*id = DatabaseUpdateManager.updatePerioxesTable(info[1], nomos,connection);
				System.out.println(id);
				System.out.println("NEW ID   ="+id);
				System.out.println("UpdatePerioxesTable   :"+info[1]);
				perioxh = new IdDescription(id,info[1]);*/
			}
			
		   } // Allagh sta IF Parakatw htan (perioxh!=null)
//*************************************************************************************************************************				
		if (perioxh!=null){
			 SearchInfo searchInfo = new SearchInfo();
			if (advType==AnnKeywords.SELL_HOUSE_CODE)
			{
				searchInfo.setSold(true);
			}
			if (advType==AnnKeywords.RENT_HOUSE_CODE){
				searchInfo.setOffer(1);
			}
			if(advType==AnnKeywords.SELL_EARTH_CODE)
			{
				searchInfo.setSold(true);
			}
		    searchInfo.setCategory(new IdDescription(advType));
		    searchInfo.setDate(new java.sql.Date(System.currentTimeMillis()));
		    searchInfo.setNomos(new IdDescription(nomos));
		    //searchInfo.setOffer(1);
		    searchInfo.setPerioxh(perioxh);
		    searchInfo.setSourceId(AnnKeywords.KATHIMERINI);
		    //searchInfo.setSearchId(DatabaseUpdateManager.updateSearchTable(searchInfo,connection));
			ReadSource advsReadSource = new ReadSource(MAIN_URL + info[0],
					AnnKeywords.KATHIMERINI);
			String advsSource = advsReadSource.getSource();
			String advsText = Utilities.getText(advsSource, ADVS_START_TAG,
					ADVS_END_TAG);
			String[] advs = advsText.split(DEVIDE_TAG);
		
//*********************************************************************************************************************
//Elenxos gia to ean oi sugkekrimenes aggelies tou Nomou Attikhs aforoun Pwlhsh h Enoikiash Katoikiwn
//*********************************************************************************************************************	
		if ((advType == AnnKeywords.SELL_HOUSE_CODE)|| (advType == AnnKeywords.RENT_HOUSE_CODE)) {
			for (String adv : advs) {
				HouseAnnouncement houseAnn = new HouseAnnouncement();
				houseAnn.setMainArea(new IdDescription(perioxh.getId(), info[1]));
				houseAnn.setRent(isRent);
			//	System.out.println(houseAnn);
				KathimeriniHouseFeatExtr featExtr = new KathimeriniHouseFeatExtr(adv, houseAnn, 0, connection);
				featExtr.editAnnFeatures();
				houseAnn = featExtr.getFeatures();
				//System.out.println("ANN:"+houseAnn);
				
			//DatabaseUpdateManager.updateHouseAnnTable(new Announcement(),houseAnn,searchInfo.getSearchId(),advType,connection);
			}
		}
//*********************************************************************************************************************
		
//*********************************************************************************************************************
//Periptwsh opou oi sugkekrimenes aggelies tou Nomou Attikhs aforoun Pwlhsh h Enoikiash Katoikiwn
//*********************************************************************************************************************
		else {
			for (String adv : advs) {
				PlotSellingAnnouncement plotAnn = new PlotSellingAnnouncement();
				plotAnn.setMainAreaType(new IdDescription(id, info[1]));
				KathimeriniEarthFeatExtr featExtr = new KathimeriniEarthFeatExtr(adv, plotAnn, 0, connection);
				featExtr.editAnnFeatures();
				plotAnn = featExtr.getFeatures();
			//	System.out.println("ANN:"+plotAnn);
				//DatabaseUpdateManager.updateSellEarthAnnTable(new Announcement(),plotAnn,searchInfo.getSearchId(),connection);
			}
		}
//*********************************************************************************************************************
		
		}//if
		
	}//for
	
}//advextraction
//*********************************************************************************************************************
//fixPerioxes() Method .Checks if MainArea Of Advertisment Already exists on Database
//*********************************************************************************************************************
private IdDescription fixPerioxes(String perioxh,ArrayList<IdDescription> areaNames) {
	for (IdDescription areaName : areaNames) {
		//System.out.println(areaName.getDescription());
		if (areaName.getDescription().equals(perioxh)
				|| WordUtilities.findDistance(areaName.getDescription(),
						perioxh) <= 1
				|| areaName.getDescription().toUpperCase().equals(perioxh)
				|| perioxh.toUpperCase().equals(areaName.getDescription())
				|| WordUtilities.findDistance(perioxh.toUpperCase(), areaName
						.getDescription().toUpperCase()) <= 1) 
			{
			//System.out.println("Area Already Exists"+ areaName);
			return areaName;
		}
	}
	return null;
}
//*********************************************************************************************************************
//*********************************************************************************************************************
//OpenMySQLConnection() Method.Establishes  A New Connection With Database
//*********************************************************************************************************************
protected boolean openMySQLConnection() {
		try {
			Class.forName("com.mysql.jdbc.Driver");
			Properties props = new Properties();
			props.put("user", "root");
			props.put("password", "");
			props.put("useUnicode", "true");
			props.put("characterEncoding", "utf-8");
			connection = DriverManager.getConnection(
					"jdbc:mysql://localhost:3306/temp09062009", props);
			/*connection = DriverManager.getConnection(
					"jdbc:mysql://localhost/temp09062009", props);*/
			return true;
		} catch (Exception e) {
			e.printStackTrace();
		System.out.	println("ERROR: Failed to get connection to database!");
			return false;
		}
	}

//*********************************************************************************************************************


//*********************************************************************************************************************
public static void main(String args[]) {
		
	    KathimeriniAdv advs1 = new 	KathimeriniAdv(AnnKeywords.SELL_HOUSE_CODE);
	    KathimeriniAdv advs2 = new KathimeriniAdv(AnnKeywords.SELL_EARTH_CODE);
		KathimeriniAdv advs3 = new KathimeriniAdv(AnnKeywords.RENT_HOUSE_CODE);
		//*****************************************************************************************
		//Syllogh Olwn Twn Aggeliwn
		//*****************************************************************************************
		//KathimeriniAdv adv=new KathimeriniAdv();
		//*****************************************************************************************
		
	}
}//public class KathimeriniAdv






