package crawling.kathimerini;

import java.sql.Connection;
import java.util.ArrayList;

import crawling.AnnKeywords;
import crawling.Utilities;
import crawling.database.DatabaseSelectManager;
import crawling.entities.DoubleStringFormat;
import crawling.entities.IdDescription;
import crawling.entities.PlotSellingAnnouncement;
import crawling.*;

public class KathimeriniEarthFeatExtr extends AnnFeatExtraction{
	
	private String advText;

	private PlotSellingAnnouncement features;

	private int nomosId;

	private Connection connection;

	public KathimeriniEarthFeatExtr(String advText, int nomosId,
			Connection connection) {
		super(0, advText, connection);
		this.advText = advText;
	}

	public KathimeriniEarthFeatExtr(String advText, PlotSellingAnnouncement features,
			int nomosId, Connection connection) {
		super(0, advText, connection);
		this.advText = advText;
		this.features = features;
	}

	protected void editAnnFeatures() {
		String[] annPieces = advText.split(",");
		DoubleStringFormat embadon = null;
		String price = null;
		String sxedio = null;
		ArrayList<String> phones = new ArrayList<String>(0);
		advText = advText.replace("<B>" + features.getMainAreaType().getDescription()
				+ "</B>", "");
		annPieces = advText.split(",");
		for (String piece : annPieces) {
			price = getPrice(piece.split(" "));
			if (price != null) {
				String priceNum = Utilities.getOnlyNumbers(price);
				if (!priceNum.equals("")) {
					if (price.contains(AnnKeywords.ANA_XRONO)
							|| price.contains(AnnKeywords.ETHSIW)) {
						features.setPrice(Double.parseDouble(priceNum) / 12);
					} else {
						features.setPrice(Double.parseDouble(priceNum));
					}
					advText = advText.replace(AnnKeywords.TIMH, "");
					advText = advText.replace(AnnKeywords.EYRW, "");
					advText = advText.replace(price, "");
					break;
				}
			}
		}
		IdDescription typeOfEarth;
		annPieces = advText.split(",");
		for (String piece : annPieces) {
			typeOfEarth = getType(piece.split(" "), DatabaseSelectManager
					.getTypesOfEarth(getConnection()));
			if (typeOfEarth != null) {
				features.setType(typeOfEarth);
				advText = advText.replace(typeOfEarth.getDescription(), "");
				advText = advText.replace(typeOfEarth.getDescription().toUpperCase(),"");
				break;
			}
		}
		
		for (String piece : annPieces) {
			embadon = getEmbadon(piece.split(" "));
			if (embadon != null) {
				break;
			}
		}
		if (embadon != null) {
			features.setEmbadon(embadon);
			advText = advText.replace(embadon.getStringFormat(),"");
		}
		for(String piece : annPieces){
			sxedio = getSxedio(piece.split(" "));
			if(sxedio != null){
				features.setInMap(sxedio);
				String[] outText = sxedio.split(" ");
				for(String out : outText){
					advText = advText.replace(out, "");
				}
				break;
			}
		}
		for(String piece :annPieces){
			phones = getPhones2(piece.split(" "));
			if(phones!=null){
				break;
			}
		}
		if(phones!=null){
			features.setPhones(phones);
			for(String phone:phones){
			advText = advText.replace(phone,"");
			}
			advText = advText.replace(AnnKeywords.THLEFWNO,"");
			advText = advText.replace(AnnKeywords.THLEPIKOINWNIAS,"");
			advText = advText.replace(AnnKeywords.THL,"");
			advText = advText.replace(AnnKeywords.THLMIKRO,"");
		}
		advText = advText.replace(", ,","");
		advText = advText.replace(",  ,","");
		advText = advText.replace(" ,   , ","");
		advText = advText.replace(" ,    ,","");
		advText = advText.replace("()","");
		features.setOtherFeatures(advText);
	}


	public PlotSellingAnnouncement getFeatures() {
		return features;
	}

	public void setFeatures(PlotSellingAnnouncement features) {
		this.features = features;
	}

}
