/****************************************
 * 			Syrgiannis Sotirios         *  
 ****************************************/
package crawling.neomesitikh;

import java.sql.Connection;
import java.sql.DriverManager;
import java.util.ArrayList;
import java.util.Properties;

import crawling.AnnKeywords;
import crawling.ReadSource;
import crawling.Utilities;
import crawling.database.DatabaseUpdateManager;
import crawling.entities.Announcement;
import crawling.entities.HouseAnnouncement;
import crawling.entities.IdDescription;
import crawling.entities.PlotSellingAnnouncement;
import crawling.entities.SearchInfo;
import crawling.*;
public class NeomesitikhAdvs {
//**************************************************************************************************************************************
//Crawling Urls
//**************************************************************************************************************************************	
	public static final String OIKOPEDA_URL = "http://www.neomesitiki.gr/index.php?option=com_ezrealty&Itemid=46&task=viewcategory&id=2&limit=50&limitstart=0";
	public static final String KATOIKIA_URL = "http://www.neomesitiki.gr/index.php?option=com_ezrealty&task=viewcategory&id=1&Itemid=46";
// *************************************************************************************************************************************
//********************************************************************************************************	
//Extraction Tags
//********************************************************************************************************	
	private static final String URL_START_TAG = "<span style=\"color: #ffcc00\">";
	private static final String URL_END_TAG = "</div>";

	private static final String ANN_START_TAG = "class=\"description\"> <p>";
	private static final String ANN_END_TAG = "</p>";

	private static final String MAIN_URL = "http://www.neomesitiki.gr/";
//********************************************************************************************************	
	private Connection connection;

//********************************************************************************************************
//Constructor Of Neomesitikh	
//********************************************************************************************************	
	public NeomesitikhAdvs() {
		if (openMySQLConnection()) {
			editDatabase();
		} else {
			System.out.println("FATAL ERROR");
			System.exit(0);
		}
	}
//********************************************************************************************************
	
// ********************************************************************************************************
// Pwlhseis Oikopedwn
// ********************************************************************************************************
	private void editDatabase() {
		ArrayList<IdDescription> advs = getAdvs(AnnKeywords.PWLHSEIS_OIKOPEDWN);
		for (IdDescription adv : advs) {
			NeomesitikhEarthFeatExtraction featExtraction = new NeomesitikhEarthFeatExtraction(
					adv.getDescription(), connection);
			PlotSellingAnnouncement plot = featExtraction.getAnnFeatures();
			if (plot != null) {
				SearchInfo searchInfo = featExtraction.getSearchInfo();
				if (adv.getId() == 1) {
					searchInfo.setSold(true);
				} else {
					searchInfo.setSold(false);
				}
				searchInfo.setOffer(0);
				searchInfo.setCategory(new IdDescription(
						AnnKeywords.SELL_EARTH_CODE));
				searchInfo.setSourceId(AnnKeywords.NEOMESITIKH);
				searchInfo.setDate(new java.sql.Date(System.currentTimeMillis()));
				int searchId = DatabaseUpdateManager.updateSearchTable(
						searchInfo, connection);
				// if(plot.getPrice()!=null && plot.getPrice()<1000000){
				DatabaseUpdateManager.updateSellEarthAnnTable(
						new Announcement(), plot, searchId, connection);
				// }
			}
		}
// ********************************************************************************************************

// ********************************************************************************************************
// Pwlhseis Katoikiwn
// ********************************************************************************************************
		ArrayList<IdDescription> advsKatoikiwn = getAdvs(AnnKeywords.PWLHSEIS_KATOIKIWN);
		for (IdDescription adv : advsKatoikiwn) {
			NeomesitikhHouseFeatExtraction featExtraction = new NeomesitikhHouseFeatExtraction(
					connection, adv.getDescription());
			HouseAnnouncement houseAnn = featExtraction.getHouseAnn();
			if (houseAnn != null) {
				SearchInfo searchInfo = featExtraction.getSearchInfo();
				if (adv.getId() == 1) {
					searchInfo.setSold(true);
				} else {
					searchInfo.setSold(false);
				}
				searchInfo.setOffer(0);
				searchInfo.setCategory(new IdDescription(
						AnnKeywords.SELL_HOUSE_CODE));
				searchInfo.setSourceId(AnnKeywords.NEOMESITIKH);
				searchInfo	
						.setDate(new java.sql.Date(System.currentTimeMillis()));
				int searchId = DatabaseUpdateManager.updateSearchTable(
						searchInfo, connection);
				DatabaseUpdateManager.updateHouseAnnTable(new Announcement(),
						houseAnn, searchId, AnnKeywords.SELL_HOUSE_CODE,
						connection);

			}
		}
	}

// ********************************************************************************************************

// ********************************************************************************************************
// Methodos getAdvs(Pragmatopoieitai extraction apo to Source code) tou text
// pou afora tis aggelies
// ********************************************************************************************************
	private ArrayList<IdDescription> getAdvs(String category) {
		ArrayList<IdDescription> advs = new ArrayList<IdDescription>(0);
		String pageSource = null;
		ReadSource src = null;
		if (category.equals(AnnKeywords.PWLHSEIS_OIKOPEDWN)) {
			// System.out.println(OIKOPEDA_URL);
			src = new ReadSource(OIKOPEDA_URL, AnnKeywords.NEOMESITIKH);
		} else if (category.equals(AnnKeywords.PWLHSEIS_KATOIKIWN)) {
			src = new ReadSource(KATOIKIA_URL, AnnKeywords.NEOMESITIKH);
		}
		pageSource = src.getSource();
		// System.out.println(pageSource);
		ArrayList<String> urls = Utilities.extractAllTexts(pageSource,
				URL_START_TAG, URL_END_TAG);
		int counter = 1;
		System.out.println("**************************************************");
		System.out.println(" ÐçãÞ:ÍåïìåóéôéêÞ\n" + " Ôýðïò Áããåëßùí : "
				+ category + "");
		System.out.println("**************************************************");
		for (String url : urls) {
			String temp = url.replace("</span>", "");
			String temp1 = temp.replace("<span>", "");
			int isSold = 0;
			counter++;
			if (temp1.contains("<span style=\"color: #ffcc00\">")) {
				String temp2 = temp1.replace("<span style=\"color: #ffcc00\">","");
				//System.out.println(temp2);
				advs.add(new IdDescription(isSold, temp2));
			} else {
				//System.out.println(temp1);
				advs.add(new IdDescription(isSold, temp1));
			}
//*********************************************************************************************************************

// **********************************************************************************************************************
// Apa Palaiotero Crawling,exei allaksei h domh ths Neomesitikhs
// **********************************************************************************************************************
			// System.out.println("URL"+url);

			// int isSold=0;
			// counter++;
			// String tempURL=MAIN_URL+url;
			// ReadSource tempSrc = new
			// ReadSource(tempURL,AnnKeywords.NEOMESITIKH);
			// String tempPageSource = tempSrc.getSource();
			// if(tempPageSource.contains(AnnKeywords.SOLD_KEYWORD)){
			// isSold=1;
			// }
			// Prepei na ginei allagh wste na ginetai add to text pou exei ginei
			// extract apo to source code ths html
			//
			// advs.add(new IdDescription(isSold,temp1));
		}

		// System.out.println("COUNTER= "+counter);
// **********************************************************************************************************************
		return advs;
	}
	//*********************************************************************************************************************
	/**
	 * Opens a connection with the mysql connection of ptyxiakh database
	 */
//*********************************************************************************************************************
	protected boolean openMySQLConnection() {
		try {
			Class.forName("com.mysql.jdbc.Driver");
			Properties props = new Properties();
			props.put("user", "root");
			props.put("password", "");
			props.put("useUnicode", "true");
			props.put("characterEncoding", "utf-8");
			connection = DriverManager.getConnection(
					"jdbc:mysql://localhost:3306/temporary", props);
			return true;
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println("ERROR: Failed to get connection to database!");
			return false;
		}
	}
//*********************************************************************************************************************


// ********************************************************************************************************
	public static void main(String[] args) {
		NeomesitikhAdvs neomisitikhAdvs = new NeomesitikhAdvs();
		System.out.println("Finished Neomesitikh");
	}

}
